{-# LANGUAGE ForeignFunctionInterface #-}
-- | Main compiler executable.

module Main where

import           Fay
import Fay.Types
import Fay.Compiler
import GHCJS.Types (JSVal)
import Data.JSString (JSString, pack, unpack)
import GHCJS.Foreign (fromJSBool, toJSBool)
import GHCJS.Foreign.Callback (Callback, asyncCallback)

foreign import javascript safe
   "try { eval($1); } catch (err) { textarea.setValue('Error while executing Fay code:\\n\\n' + err); textarea.setOption('mode', 'text/plain'); textarea.setOption('lineWrapping', true); }"
   evalAux :: JSString -> IO ()
eval = evalAux . pack

doCompile :: String -> IO (Maybe String)
doCompile source = do res <- compileViaStr "Main.hs" (defaultConfig {configTypecheck = False, configExportRuntime = False, configExportStdlib = False}) (compileToplevelModuleText "Main.hs" source) source
                      case res of
                        Right (b , _, _) -> do {setCodeMirrorValue2 "";
                                                setCodeMirror2Highlight;
                                                eval (rt ++ (pwOutputString (execPrinter b defaultPrintReader)) ++ "Fay$$_(Main.main, true);");
                                                return Nothing}
                        Left o -> return $ Just $ show o

rt :: String
rt = "\n/*******************************************************************************\n * Misc.\n */\n\n\n// Workaround for missing functionality in IE 8 and earlier.\nif( Object.create === undefined ) {\n  Object.create = function( o ) {\n    function F(){}\n    F.prototype = o;\n    return new F();\n  };\n}\n\n// Insert properties of b in place into a.\nfunction Fay$$objConcat(a,b){\n  for (var p in b) if (b.hasOwnProperty(p)){\n    a[p] = b[p];\n  }\n  return a;\n}\n\n/*******************************************************************************\n * Thunks.\n */\n\n// Force a thunk (if it is a thunk) until WHNF.\nfunction Fay$$_(thunkish,nocache){\n  while (thunkish instanceof Fay$$$) {\n    thunkish = thunkish.force(nocache);\n  }\n  return thunkish;\n}\n\n// Apply a function to arguments (see method2 in Fay.hs).\nfunction Fay$$__(){\n  var f = arguments[0];\n  for (var i = 1, len = arguments.length; i < len; i++) {\n    f = (f instanceof Fay$$$? Fay$$_(f) : f)(arguments[i]);\n  }\n  return f;\n}\n\n// Thunk object.\nfunction Fay$$$(value){\n  this.forced = false;\n  this.value = value;\n}\n\n// Force the thunk.\nFay$$$.prototype.force = function(nocache) {\n  return nocache ?\n    this.value() :\n    (this.forced ?\n     this.value :\n     (this.value = this.value(), this.forced = true, this.value));\n};\n\n\nfunction Fay$$seq(x) {\n  return function(y) {\n    Fay$$_(x,false);\n    return y;\n  }\n}\n\nfunction Fay$$seq$36$uncurried(x,y) {\n  Fay$$_(x,false);\n  return y;\n}\n\n/*******************************************************************************\n * Monad.\n */\n\nfunction Fay$$Monad(value){\n  this.value = value;\n}\n\n// This is used directly from Fay, but can be rebound or shadowed. See primOps in Types.hs.\n// >>\nfunction Fay$$then(a){\n  return function(b){\n    return Fay$$bind(a)(function(_){\n      return b;\n    });\n  };\n}\n\n// This is used directly from Fay, but can be rebound or shadowed. See primOps in Types.hs.\n// >>\nfunction Fay$$then$36$uncurried(a,b){\n  return Fay$$bind$36$uncurried(a,function(_){ return b; });\n}\n\n// >>=\n// This is used directly from Fay, but can be rebound or shadowed. See primOps in Types.hs.\nfunction Fay$$bind(m){\n  return function(f){\n    return new Fay$$$(function(){\n      var monad = Fay$$_(m,true);\n      return Fay$$_(f)(monad.value);\n    });\n  };\n}\n\n// >>=\n// This is used directly from Fay, but can be rebound or shadowed. See primOps in Types.hs.\nfunction Fay$$bind$36$uncurried(m,f){\n  return new Fay$$$(function(){\n    var monad = Fay$$_(m,true);\n    return Fay$$_(f)(monad.value);\n  });\n}\n\n// This is used directly from Fay, but can be rebound or shadowed.\nfunction Fay$$$_return(a){\n  return new Fay$$Monad(a);\n}\n\n// Allow the programmer to access thunk forcing directly.\nfunction Fay$$force(thunk){\n  return function(type){\n    return new Fay$$$(function(){\n      Fay$$_(thunk,type);\n      return new Fay$$Monad(Fay$$unit);\n    })\n  }\n}\n\n// This is used directly from Fay, but can be rebound or shadowed.\nfunction Fay$$return$36$uncurried(a){\n  return new Fay$$Monad(a);\n}\n\n// Unit: ().\nvar Fay$$unit = null;\n\n/*******************************************************************************\n * Serialization.\n * Fay <-> JS. Should be bijective.\n */\n\n// Serialize a Fay object to JS.\nfunction Fay$$fayToJs(type,fayObj){\n  var base = type[0];\n  var args = type[1];\n  var jsObj;\n  if(base == \"action\") {\n    // A nullary monadic action. Should become a nullary JS function.\n    // Fay () -> function(){ return ... }\n    return function(){\n      return Fay$$fayToJs(args[0],Fay$$_(fayObj,true).value);\n    };\n\n  }\n  else if(base == \"function\") {\n    // A proper function.\n    return function(){\n      var fayFunc = fayObj;\n      var return_type = args[args.length-1];\n      var len = args.length;\n      // If some arguments.\n      if (len > 1) {\n        // Apply to all the arguments.\n        fayFunc = Fay$$_(fayFunc,true);\n        // TODO: Perhaps we should throw an error when JS\n        // passes more arguments than Haskell accepts.\n\n        // Unserialize the JS values to Fay for the Fay callback.\n        if (args == \"automatic_function\")\n        {\n          for (var i = 0; i < arguments.length; i++) {\n            fayFunc = Fay$$_(fayFunc(Fay$$jsToFay([\"automatic\"],arguments[i])),true);\n          }\n          return Fay$$fayToJs([\"automatic\"], fayFunc);\n        }\n\n        for (var i = 0, len = len; i < len - 1 && fayFunc instanceof Function; i++) {\n          fayFunc = Fay$$_(fayFunc(Fay$$jsToFay(args[i],arguments[i])),true);\n        }\n        // Finally, serialize the Fay return value back to JS.\n        var return_base = return_type[0];\n        var return_args = return_type[1];\n        // If it's a monadic return value, get the value instead.\n        if(return_base == \"action\") {\n          return Fay$$fayToJs(return_args[0],fayFunc.value);\n        }\n        // Otherwise just serialize the value direct.\n        else {\n          return Fay$$fayToJs(return_type,fayFunc);\n        }\n      } else {\n        throw new Error(\"Nullary function?\");\n      }\n    };\n\n  }\n  else if(base == \"string\") {\n    return Fay$$fayToJs_string(fayObj);\n  }\n  else if(base == \"list\") {\n    // Serialize Fay list to JavaScript array.\n    var arr = [];\n    fayObj = Fay$$_(fayObj);\n    while(fayObj instanceof Fay$$Cons) {\n      arr.push(Fay$$fayToJs(args[0],fayObj.car));\n      fayObj = Fay$$_(fayObj.cdr);\n    }\n    return arr;\n  }\n  else if(base == \"tuple\") {\n    // Serialize Fay tuple to JavaScript array.\n    var arr = [];\n    fayObj = Fay$$_(fayObj);\n    var i = 0;\n    while(fayObj instanceof Fay$$Cons) {\n      arr.push(Fay$$fayToJs(args[i++],fayObj.car));\n      fayObj = Fay$$_(fayObj.cdr);\n    }\n    return arr;\n  }\n  else if(base == \"defined\") {\n    fayObj = Fay$$_(fayObj);\n    return fayObj instanceof Fay.FFI._Undefined\n      ? undefined\n      : Fay$$fayToJs(args[0],fayObj.slot1);\n  }\n  else if(base == \"nullable\") {\n    fayObj = Fay$$_(fayObj);\n    return fayObj instanceof Fay.FFI._Null\n      ? null\n      : Fay$$fayToJs(args[0],fayObj.slot1);\n  }\n  else if(base == \"double\" || base == \"int\" || base == \"bool\") {\n    // Bools are unboxed.\n    return Fay$$_(fayObj);\n  }\n  else if(base == \"ptr\")\n    return fayObj;\n  else if(base == \"unknown\")\n    return Fay$$fayToJs([\"automatic\"], fayObj);\n  else if(base == \"automatic\" && fayObj instanceof Function) {\n    return Fay$$fayToJs([\"function\", \"automatic_function\"], fayObj);\n  }\n  else if(base == \"automatic\" || base == \"user\") {\n    fayObj = Fay$$_(fayObj);\n\n    if(fayObj instanceof Fay$$Cons || fayObj === null){\n      // Serialize Fay list to JavaScript array.\n      var arr = [];\n      while(fayObj instanceof Fay$$Cons) {\n        arr.push(Fay$$fayToJs([\"automatic\"],fayObj.car));\n        fayObj = Fay$$_(fayObj.cdr);\n      }\n      return arr;\n    } else {\n      var fayToJsFun = fayObj && fayObj.instance && Fay$$fayToJsHash[fayObj.instance];\n      return fayToJsFun ? fayToJsFun(type,type[2],fayObj) : fayObj;\n    }\n  }\n\n  throw new Error(\"Unhandled Fay->JS translation type: \" + base);\n}\n\n// Stores the mappings from fay types to js objects.\n// This will be populated by compiled modules.\nvar Fay$$fayToJsHash = {};\n\n// Specialized serializer for string.\nfunction Fay$$fayToJs_string(fayObj){\n  // Serialize Fay string to JavaScript string.\n  var str = \"\";\n  fayObj = Fay$$_(fayObj);\n  while(fayObj instanceof Fay$$Cons) {\n    str += Fay$$_(fayObj.car);\n    fayObj = Fay$$_(fayObj.cdr);\n  }\n  return str;\n};\nfunction Fay$$jsToFay_string(x){\n  return Fay$$list(x)\n};\n\n// Special num/bool serializers.\nfunction Fay$$jsToFay_int(x){return x;}\nfunction Fay$$jsToFay_double(x){return x;}\nfunction Fay$$jsToFay_bool(x){return x;}\n\nfunction Fay$$fayToJs_int(x){return Fay$$_(x);}\nfunction Fay$$fayToJs_double(x){return Fay$$_(x);}\nfunction Fay$$fayToJs_bool(x){return Fay$$_(x);}\n\n// Unserialize an object from JS to Fay.\nfunction Fay$$jsToFay(type,jsObj){\n  var base = type[0];\n  var args = type[1];\n  var fayObj;\n  if(base == \"action\") {\n    // Unserialize a \"monadic\" JavaScript return value into a monadic value.\n    return new Fay$$Monad(Fay$$jsToFay(args[0],jsObj));\n  }\n  else if(base == \"function\") {\n    // Unserialize a function from JavaScript to a function that Fay can call.\n    // So\n    //\n    //    var f = function(x,y,z){ \8230 }\n    //\n    // becomes something like:\n    //\n    //    function(x){\n    //      return function(y){\n    //        return function(z){\n    //          return new Fay$$$(function(){\n    //            return Fay$$jsToFay(f(Fay$$fayTojs(x),\n    //                                  Fay$$fayTojs(y),\n    //                                  Fay$$fayTojs(z))\n    //    }}}}};\n    var returnType = args[args.length-1];\n    var funArgs = args.slice(0,-1);\n\n    if (jsObj.length > 0) {\n      var makePartial = function(args){\n        return function(arg){\n          var i = args.length;\n          var fayArg = Fay$$fayToJs(funArgs[i],arg);\n          var newArgs = args.concat([fayArg]);\n          if(newArgs.length == funArgs.length) {\n            return new Fay$$$(function(){\n              return Fay$$jsToFay(returnType,jsObj.apply(this,newArgs));\n            });\n          } else {\n            return makePartial(newArgs);\n          }\n        };\n      };\n      return makePartial([]);\n    }\n    else\n      return function (arg) {\n        return Fay$$jsToFay([\"automatic\"], jsObj(Fay$$fayToJs([\"automatic\"], arg)));\n      };\n  }\n  else if(base == \"string\") {\n    // Unserialize a JS string into Fay list (String).\n    // This is a special case, when String is explicit in the type signature,\n    // with `Automatic' a string would not be decoded.\n    return Fay$$list(jsObj);\n  }\n  else if(base == \"list\") {\n    // Unserialize a JS array into a Fay list ([a]).\n    var serializedList = [];\n    for (var i = 0, len = jsObj.length; i < len; i++) {\n      // Unserialize each JS value into a Fay value, too.\n      serializedList.push(Fay$$jsToFay(args[0],jsObj[i]));\n    }\n    // Pop it all in a Fay list.\n    return Fay$$list(serializedList);\n  }\n  else if(base == \"tuple\") {\n    // Unserialize a JS array into a Fay tuple ((a,b,c,...)).\n    var serializedTuple = [];\n    for (var i = 0, len = jsObj.length; i < len; i++) {\n      // Unserialize each JS value into a Fay value, too.\n      serializedTuple.push(Fay$$jsToFay(args[i],jsObj[i]));\n    }\n    // Pop it all in a Fay list.\n    return Fay$$list(serializedTuple);\n  }\n  else if(base == \"defined\") {\n    return jsObj === undefined\n      ? new Fay.FFI._Undefined()\n      : new Fay.FFI._Defined(Fay$$jsToFay(args[0],jsObj));\n  }\n  else if(base == \"nullable\") {\n    return jsObj === null\n      ? new Fay.FFI._Null()\n      : new Fay.FFI.Nullable(Fay$$jsToFay(args[0],jsObj));\n  }\n  else if(base == \"int\") {\n    // Int are unboxed, so there's no forcing to do.\n    // But we can do validation that the int has no decimal places.\n    // E.g. Math.round(x)!=x? throw \"NOT AN INTEGER, GET OUT!\"\n    fayObj = Math.round(jsObj);\n    if(fayObj!==jsObj) throw \"Argument \" + jsObj + \" is not an integer!\";\n    return fayObj;\n  }\n  else if (base == \"double\" ||\n           base == \"bool\" ||\n           base ==  \"ptr\") {\n    return jsObj;\n  }\n  else if(base == \"unknown\")\n    return Fay$$jsToFay([\"automatic\"], jsObj);\n  else if(base == \"automatic\" && jsObj instanceof Function) {\n    var type = [[\"automatic\"]];\n    for (var i = 0; i < jsObj.length; i++)\n      type.push([\"automatic\"]);\n    return Fay$$jsToFay([\"function\", type], jsObj);\n  }\n  else if(base == \"automatic\" && jsObj instanceof Array) {\n    var list = null;\n    for (var i = jsObj.length - 1; i >= 0; i--) {\n      list = new Fay$$Cons(Fay$$jsToFay([base], jsObj[i]), list);\n    }\n    return list;\n  }\n  else if(base == \"automatic\" || base == \"user\") {\n    if (jsObj && jsObj['instance']) {\n      var jsToFayFun = Fay$$jsToFayHash[jsObj[\"instance\"]];\n      return jsToFayFun ? jsToFayFun(type,type[2],jsObj) : jsObj;\n    }\n    else\n      return jsObj;\n  }\n\n  throw new Error(\"Unhandled JS->Fay translation type: \" + base);\n}\n\n// Stores the mappings from js objects to fay types.\n// This will be populated by compiled modules.\nvar Fay$$jsToFayHash = {};\n\n/*******************************************************************************\n * Lists.\n */\n\n// Cons object.\nfunction Fay$$Cons(car,cdr){\n  this.car = car;\n  this.cdr = cdr;\n}\n\n// Make a list.\nfunction Fay$$list(xs){\n  var out = null;\n  for(var i=xs.length-1; i>=0;i--)\n    out = new Fay$$Cons(xs[i],out);\n  return out;\n}\n\n// Built-in list cons.\nfunction Fay$$cons(x){\n  return function(y){\n    return new Fay$$Cons(x,y);\n  };\n}\n\n// List index.\n// `list' is already forced by the time it's passed to this function.\n// `list' cannot be null and `index' cannot be out of bounds.\nfunction Fay$$index(index,list){\n  for(var i = 0; i < index; i++) {\n    list = Fay$$_(list.cdr);\n  }\n  return list.car;\n}\n\n// List length.\n// `list' is already forced by the time it's passed to this function.\nfunction Fay$$listLen(list,max){\n  for(var i = 0; list !== null && i < max + 1; i++) {\n    list = Fay$$_(list.cdr);\n  }\n  return i == max;\n}\n\n/*******************************************************************************\n * Numbers.\n */\n\n// Built-in *.\nfunction Fay$$mult(x){\n  return function(y){\n    return new Fay$$$(function(){\n      return Fay$$_(x) * Fay$$_(y);\n    });\n  };\n}\n\nfunction Fay$$mult$36$uncurried(x,y){\n\n  return new Fay$$$(function(){\n    return Fay$$_(x) * Fay$$_(y);\n  });\n\n}\n\n// Built-in +.\nfunction Fay$$add(x){\n  return function(y){\n    return new Fay$$$(function(){\n      return Fay$$_(x) + Fay$$_(y);\n    });\n  };\n}\n\n// Built-in +.\nfunction Fay$$add$36$uncurried(x,y){\n\n  return new Fay$$$(function(){\n    return Fay$$_(x) + Fay$$_(y);\n  });\n\n}\n\n// Built-in -.\nfunction Fay$$sub(x){\n  return function(y){\n    return new Fay$$$(function(){\n      return Fay$$_(x) - Fay$$_(y);\n    });\n  };\n}\n// Built-in -.\nfunction Fay$$sub$36$uncurried(x,y){\n\n  return new Fay$$$(function(){\n    return Fay$$_(x) - Fay$$_(y);\n  });\n\n}\n\n// Built-in /.\nfunction Fay$$divi(x){\n  return function(y){\n    return new Fay$$$(function(){\n      return Fay$$_(x) / Fay$$_(y);\n    });\n  };\n}\n\n// Built-in /.\nfunction Fay$$divi$36$uncurried(x,y){\n\n  return new Fay$$$(function(){\n    return Fay$$_(x) / Fay$$_(y);\n  });\n\n}\n\n/*******************************************************************************\n * Booleans.\n */\n\n// Are two values equal?\nfunction Fay$$equal(lit1, lit2) {\n  // Simple case\n  lit1 = Fay$$_(lit1);\n  lit2 = Fay$$_(lit2);\n  if (lit1 === lit2) {\n    return true;\n  }\n  // General case\n  if (lit1 instanceof Array) {\n    if (lit1.length != lit2.length) return false;\n    for (var len = lit1.length, i = 0; i < len; i++) {\n      if (!Fay$$equal(lit1[i], lit2[i])) return false;\n    }\n    return true;\n  } else if (lit1 instanceof Fay$$Cons && lit2 instanceof Fay$$Cons) {\n    do {\n      if (!Fay$$equal(lit1.car,lit2.car))\n        return false;\n      lit1 = Fay$$_(lit1.cdr), lit2 = Fay$$_(lit2.cdr);\n      if (lit1 === null || lit2 === null)\n        return lit1 === lit2;\n    } while (true);\n  } else if (typeof lit1 == 'object' && typeof lit2 == 'object' && lit1 && lit2 &&\n             lit1.instance === lit2.instance) {\n    for(var x in lit1) {\n      if(!Fay$$equal(lit1[x],lit2[x]))\n        return false;\n    }\n    return true;\n  } else {\n    return false;\n  }\n}\n\n// Built-in ==.\nfunction Fay$$eq(x){\n  return function(y){\n    return new Fay$$$(function(){\n      return Fay$$equal(x,y);\n    });\n  };\n}\n\nfunction Fay$$eq$36$uncurried(x,y){\n\n  return new Fay$$$(function(){\n    return Fay$$equal(x,y);\n  });\n\n}\n\n// Built-in /=.\nfunction Fay$$neq(x){\n  return function(y){\n    return new Fay$$$(function(){\n      return !(Fay$$equal(x,y));\n    });\n  };\n}\n\n// Built-in /=.\nfunction Fay$$neq$36$uncurried(x,y){\n\n  return new Fay$$$(function(){\n    return !(Fay$$equal(x,y));\n  });\n\n}\n\n// Built-in >.\nfunction Fay$$gt(x){\n  return function(y){\n    return new Fay$$$(function(){\n      return Fay$$_(x) > Fay$$_(y);\n    });\n  };\n}\n\n// Built-in >.\nfunction Fay$$gt$36$uncurried(x,y){\n\n  return new Fay$$$(function(){\n    return Fay$$_(x) > Fay$$_(y);\n  });\n\n}\n\n// Built-in <.\nfunction Fay$$lt(x){\n  return function(y){\n    return new Fay$$$(function(){\n      return Fay$$_(x) < Fay$$_(y);\n    });\n  };\n}\n\n\n// Built-in <.\nfunction Fay$$lt$36$uncurried(x,y){\n\n  return new Fay$$$(function(){\n    return Fay$$_(x) < Fay$$_(y);\n  });\n\n}\n\n\n// Built-in >=.\nfunction Fay$$gte(x){\n  return function(y){\n    return new Fay$$$(function(){\n      return Fay$$_(x) >= Fay$$_(y);\n    });\n  };\n}\n\n// Built-in >=.\nfunction Fay$$gte$36$uncurried(x,y){\n\n  return new Fay$$$(function(){\n    return Fay$$_(x) >= Fay$$_(y);\n  });\n\n}\n\n// Built-in <=.\nfunction Fay$$lte(x){\n  return function(y){\n    return new Fay$$$(function(){\n      return Fay$$_(x) <= Fay$$_(y);\n    });\n  };\n}\n\n// Built-in <=.\nfunction Fay$$lte$36$uncurried(x,y){\n\n  return new Fay$$$(function(){\n    return Fay$$_(x) <= Fay$$_(y);\n  });\n\n}\n\n// Built-in &&.\nfunction Fay$$and(x){\n  return function(y){\n    return new Fay$$$(function(){\n      return Fay$$_(x) && Fay$$_(y);\n    });\n  };\n}\n\n// Built-in &&.\nfunction Fay$$and$36$uncurried(x,y){\n\n  return new Fay$$$(function(){\n    return Fay$$_(x) && Fay$$_(y);\n  });\n  ;\n}\n\n// Built-in ||.\nfunction Fay$$or(x){\n  return function(y){\n    return new Fay$$$(function(){\n      return Fay$$_(x) || Fay$$_(y);\n    });\n  };\n}\n\n// Built-in ||.\nfunction Fay$$or$36$uncurried(x,y){\n\n  return new Fay$$$(function(){\n    return Fay$$_(x) || Fay$$_(y);\n  });\n\n}\n\n/*******************************************************************************\n * Mutable references.\n */\n\n// Make a new mutable reference.\nfunction Fay$$Ref(x){\n  this.value = x;\n}\n\n// Write to the ref.\nfunction Fay$$writeRef(ref,x){\n  ref.value = x;\n}\n\n// Get the value from the ref.\nfunction Fay$$readRef(ref){\n  return ref.value;\n}\n\n/*******************************************************************************\n * Dates.\n */\nfunction Fay$$date(str){\n  return Date.parse(str);\n}\n\n/*******************************************************************************\n * Data.Var\n */\n\nfunction Fay$$Ref2(val){\n  this.val = val;\n}\n\nfunction Fay$$Sig(){\n  this.handlers = [];\n}\n\nfunction Fay$$Var(val){\n  this.val = val;\n  this.handlers = [];\n}\n\n// Helper used by Fay$$setValue and for merging\nfunction Fay$$broadcastInternal(self, val, force){\n  var handlers = self.handlers;\n  var exceptions = [];\n  for(var len = handlers.length, i = 0; i < len; i++) {\n    try {\n      force(handlers[i][1](val), true);\n    } catch (e) {\n      exceptions.push(e);\n    }\n  }\n  // Rethrow the encountered exceptions.\n  if (exceptions.length > 0) {\n    console.error(\"Encountered \" + exceptions.length + \" exception(s) while broadcasing a change to \", self);\n    for(var len = exceptions.length, i = 0; i < len; i++) {\n      (function(exception) {\n        setTimeout(function() { throw exception; }, 0);\n      })(exceptions[i]);\n    }\n  }\n}\n\nfunction Fay$$setValue(self, val, force){\n  if (self instanceof Fay$$Ref2) {\n    self.val = val;\n  } else if (self instanceof Fay$$Var) {\n    self.val = val;\n    Fay$$broadcastInternal(self, val, force);\n  } else if (self instanceof Fay$$Sig) {\n    Fay$$broadcastInternal(self, val, force);\n  } else {\n    throw \"Fay$$setValue given something that's not a Ref2, Var, or Sig\"\n  }\n}\n\nfunction Fay$$subscribe(self, f){\n  var key = {};\n  self.handlers.push([key,f]);\n  var searchStart = self.handlers.length - 1;\n  return function(_){\n    for(var i = Math.min(searchStart, self.handlers.length - 1); i >= 0; i--) {\n      if(self.handlers[i][0] == key) {\n        self.handlers = self.handlers.slice(0,i).concat(self.handlers.slice(i+1));\n        return;\n      }\n    }\n    return _; // This variable has to be used, otherwise Closure\n              // strips it out and Fay serialization breaks.\n  };\n}\n\n/*******************************************************************************\n * Application code.\n */\n\nvar Data = {};Data.Data = {};var Fay = {};Fay.FFI = {};Fay.FFI._Nullable = function Nullable(slot1){this.slot1 = slot1;};Fay.FFI._Nullable.prototype.instance = \"Nullable\";Fay.FFI.Nullable = function(slot1){return new Fay$$$(function(){return new Fay.FFI._Nullable(slot1);});};Fay.FFI._Null = function Null(){};Fay.FFI._Null.prototype.instance = \"Null\";Fay.FFI.Null = new Fay$$$(function(){return new Fay.FFI._Null();});Fay.FFI._Defined = function Defined(slot1){this.slot1 = slot1;};Fay.FFI._Defined.prototype.instance = \"Defined\";Fay.FFI.Defined = function(slot1){return new Fay$$$(function(){return new Fay.FFI._Defined(slot1);});};Fay.FFI._Undefined = function Undefined(){};Fay.FFI._Undefined.prototype.instance = \"Undefined\";Fay.FFI.Undefined = new Fay$$$(function(){return new Fay.FFI._Undefined();});Fay$$objConcat(Fay$$fayToJsHash,{\"Nullable\": function(type,argTypes,_obj){var obj_ = {\"instance\": \"Nullable\"};var obj_slot1 = Fay$$fayToJs(argTypes && (argTypes)[0] ? (argTypes)[0] : (type)[0] === \"automatic\" ? [\"automatic\"] : [\"unknown\"],_obj.slot1);if (undefined !== obj_slot1) {obj_['slot1'] = obj_slot1;}return obj_;},\"Null\": function(type,argTypes,_obj){var obj_ = {\"instance\": \"Null\"};return obj_;},\"Defined\": function(type,argTypes,_obj){var obj_ = {\"instance\": \"Defined\"};var obj_slot1 = Fay$$fayToJs(argTypes && (argTypes)[0] ? (argTypes)[0] : (type)[0] === \"automatic\" ? [\"automatic\"] : [\"unknown\"],_obj.slot1);if (undefined !== obj_slot1) {obj_['slot1'] = obj_slot1;}return obj_;},\"Undefined\": function(type,argTypes,_obj){var obj_ = {\"instance\": \"Undefined\"};return obj_;}});Fay$$objConcat(Fay$$jsToFayHash,{\"Nullable\": function(type,argTypes,obj){return new Fay.FFI._Nullable(Fay$$jsToFay(argTypes && (argTypes)[0] ? (argTypes)[0] : (type)[0] === \"automatic\" ? [\"automatic\"] : [\"unknown\"],obj[\"slot1\"]));},\"Null\": function(type,argTypes,obj){return new Fay.FFI._Null();},\"Defined\": function(type,argTypes,obj){return new Fay.FFI._Defined(Fay$$jsToFay(argTypes && (argTypes)[0] ? (argTypes)[0] : (type)[0] === \"automatic\" ? [\"automatic\"] : [\"unknown\"],obj[\"slot1\"]));},\"Undefined\": function(type,argTypes,obj){return new Fay.FFI._Undefined();}});var Prelude = {};Prelude._Just = function Just(slot1){this.slot1 = slot1;};Prelude._Just.prototype.instance = \"Just\";Prelude.Just = function(slot1){return new Fay$$$(function(){return new Prelude._Just(slot1);});};Prelude._Nothing = function Nothing(){};Prelude._Nothing.prototype.instance = \"Nothing\";Prelude.Nothing = new Fay$$$(function(){return new Prelude._Nothing();});Prelude._Left = function Left(slot1){this.slot1 = slot1;};Prelude._Left.prototype.instance = \"Left\";Prelude.Left = function(slot1){return new Fay$$$(function(){return new Prelude._Left(slot1);});};Prelude._Right = function Right(slot1){this.slot1 = slot1;};Prelude._Right.prototype.instance = \"Right\";Prelude.Right = function(slot1){return new Fay$$$(function(){return new Prelude._Right(slot1);});};Prelude.maybe = function($p1){return function($p2){return function($p3){return new Fay$$$(function(){if (Fay$$_($p3) instanceof Prelude._Nothing) {var m = $p1;return m;}if (Fay$$_($p3) instanceof Prelude._Just) {var x = Fay$$_($p3).slot1;var f = $p2;return Fay$$_(f)(x);}throw [\"unhandled case in maybe\",[$p1,$p2,$p3]];});};};};Prelude.$62$$62$$61$ = function($p1){return function($p2){return new Fay$$$(function(){return Fay$$_(Fay$$bind($p1)($p2));});};};Prelude.$62$$62$ = function($p1){return function($p2){return new Fay$$$(function(){return Fay$$_(Fay$$then($p1)($p2));});};};Prelude.$_return = function($p1){return new Fay$$$(function(){return new Fay$$Monad(Fay$$jsToFay([\"unknown\"],Fay$$$_return(Fay$$fayToJs([\"unknown\"],$p1))));});};Prelude.fail = new Fay$$$(function(){return Prelude.error;});Prelude.when = function($p1){return function($p2){return new Fay$$$(function(){var m = $p2;var p = $p1;return Fay$$_(p) ? m : Fay$$_(Fay$$$_return)(Fay$$unit);});};};Prelude.unless = function($p1){return function($p2){return new Fay$$$(function(){var m = $p2;var p = $p1;return Fay$$_(p) ? Fay$$_(Fay$$$_return)(Fay$$unit) : m;});};};Prelude.forM = function($p1){return function($p2){return new Fay$$$(function(){var fn = $p2;var lst = $p1;return Fay$$_(Fay$$_(Prelude.$36$)(Prelude.sequence))(Fay$$_(Fay$$_(Prelude.map)(fn))(lst));});};};Prelude.forM_ = function($p1){return function($p2){return new Fay$$$(function(){var m = $p2;var $tmp1 = Fay$$_($p1);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;return Fay$$_(Fay$$_(Fay$$then)(Fay$$_(m)(x)))(Fay$$_(Fay$$_(Prelude.forM_)(xs))(m));}if (Fay$$_($p1) === null) {return Fay$$_(Fay$$$_return)(Fay$$unit);}throw [\"unhandled case in forM_\",[$p1,$p2]];});};};Prelude.mapM = function($p1){return function($p2){return new Fay$$$(function(){var lst = $p2;var fn = $p1;return Fay$$_(Fay$$_(Prelude.$36$)(Prelude.sequence))(Fay$$_(Fay$$_(Prelude.map)(fn))(lst));});};};Prelude.mapM_ = function($p1){return function($p2){return new Fay$$$(function(){var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var m = $p1;return Fay$$_(Fay$$_(Fay$$then)(Fay$$_(m)(x)))(Fay$$_(Fay$$_(Prelude.mapM_)(m))(xs));}if (Fay$$_($p2) === null) {return Fay$$_(Fay$$$_return)(Fay$$unit);}throw [\"unhandled case in mapM_\",[$p1,$p2]];});};};Prelude.$61$$60$$60$ = function($p1){return function($p2){return new Fay$$$(function(){var x = $p2;var f = $p1;return Fay$$_(Fay$$_(Fay$$bind)(x))(f);});};};Prelude.$_void = function($p1){return new Fay$$$(function(){var f = $p1;return Fay$$_(Fay$$_(Fay$$then)(f))(Fay$$_(Fay$$$_return)(Fay$$unit));});};Prelude.$62$$61$$62$ = function($p1){return function($p2){return function($p3){return new Fay$$$(function(){var x = $p3;var g = $p2;var f = $p1;return Fay$$_(Fay$$_(Fay$$bind)(Fay$$_(f)(x)))(g);});};};};Prelude.$60$$61$$60$ = function($p1){return function($p2){return function($p3){return new Fay$$$(function(){var x = $p3;var f = $p2;var g = $p1;return Fay$$_(Fay$$_(Fay$$bind)(Fay$$_(f)(x)))(g);});};};};Prelude.sequence = function($p1){return new Fay$$$(function(){var ms = $p1;return (function(){var k = function($p1){return function($p2){return new Fay$$$(function(){var m$39$ = $p2;var m = $p1;return Fay$$_(Fay$$_(Fay$$bind)(m))(function($p1){var x = $p1;return Fay$$_(Fay$$_(Fay$$bind)(m$39$))(function($p1){var xs = $p1;return Fay$$_(Fay$$$_return)(Fay$$_(Fay$$_(Fay$$cons)(x))(xs));});});});};};return Fay$$_(Fay$$_(Fay$$_(Prelude.foldr)(k))(Fay$$_(Fay$$$_return)(null)))(ms);})();});};Prelude.sequence_ = function($p1){return new Fay$$$(function(){if (Fay$$_($p1) === null) {return Fay$$_(Fay$$$_return)(Fay$$unit);}var $tmp1 = Fay$$_($p1);if ($tmp1 instanceof Fay$$Cons) {var m = $tmp1.car;var ms = $tmp1.cdr;return Fay$$_(Fay$$_(Fay$$then)(m))(Fay$$_(Prelude.sequence_)(ms));}throw [\"unhandled case in sequence_\",[$p1]];});};Prelude._GT = function GT(){};Prelude._GT.prototype.instance = \"GT\";Prelude.GT = new Fay$$$(function(){return new Prelude._GT();});Prelude._LT = function LT(){};Prelude._LT.prototype.instance = \"LT\";Prelude.LT = new Fay$$$(function(){return new Prelude._LT();});Prelude._EQ = function EQ(){};Prelude._EQ.prototype.instance = \"EQ\";Prelude.EQ = new Fay$$$(function(){return new Prelude._EQ();});Prelude.compare = function($p1){return function($p2){return new Fay$$$(function(){var y = $p2;var x = $p1;return Fay$$_(Fay$$_(Fay$$_(Fay$$gt)(x))(y)) ? Prelude.GT : Fay$$_(Fay$$_(Fay$$_(Fay$$lt)(x))(y)) ? Prelude.LT : Prelude.EQ;});};};Prelude.succ = function($p1){return new Fay$$$(function(){var x = $p1;return Fay$$_(Fay$$_(Fay$$add)(x))(1);});};Prelude.pred = function($p1){return new Fay$$$(function(){var x = $p1;return Fay$$_(Fay$$_(Fay$$sub)(x))(1);});};Prelude.enumFrom = function($p1){return new Fay$$$(function(){var i = $p1;return Fay$$_(Fay$$_(Fay$$cons)(i))(Fay$$_(Prelude.enumFrom)(Fay$$_(Fay$$_(Fay$$add)(i))(1)));});};Prelude.enumFromTo = function($p1){return function($p2){return new Fay$$$(function(){var n = $p2;var i = $p1;return Fay$$_(Fay$$_(Fay$$_(Fay$$gt)(i))(n)) ? null : Fay$$_(Fay$$_(Fay$$cons)(i))(Fay$$_(Fay$$_(Prelude.enumFromTo)(Fay$$_(Fay$$_(Fay$$add)(i))(1)))(n));});};};Prelude.enumFromBy = function($p1){return function($p2){return new Fay$$$(function(){var by = $p2;var fr = $p1;return Fay$$_(Fay$$_(Fay$$cons)(fr))(Fay$$_(Fay$$_(Prelude.enumFromBy)(Fay$$_(Fay$$_(Fay$$add)(fr))(by)))(by));});};};Prelude.enumFromThen = function($p1){return function($p2){return new Fay$$$(function(){var th = $p2;var fr = $p1;return Fay$$_(Fay$$_(Prelude.enumFromBy)(fr))(Fay$$_(Fay$$_(Fay$$sub)(th))(fr));});};};Prelude.enumFromByTo = function($p1){return function($p2){return function($p3){return new Fay$$$(function(){var to = $p3;var by = $p2;var fr = $p1;return (function(){var neg = function($p1){return new Fay$$$(function(){var x = $p1;return Fay$$_(Fay$$_(Fay$$_(Fay$$lt)(x))(to)) ? null : Fay$$_(Fay$$_(Fay$$cons)(x))(Fay$$_(neg)(Fay$$_(Fay$$_(Fay$$add)(x))(by)));});};var pos = function($p1){return new Fay$$$(function(){var x = $p1;return Fay$$_(Fay$$_(Fay$$_(Fay$$gt)(x))(to)) ? null : Fay$$_(Fay$$_(Fay$$cons)(x))(Fay$$_(pos)(Fay$$_(Fay$$_(Fay$$add)(x))(by)));});};return Fay$$_(Fay$$_(Fay$$_(Fay$$lt)(by))(0)) ? Fay$$_(neg)(fr) : Fay$$_(pos)(fr);})();});};};};Prelude.enumFromThenTo = function($p1){return function($p2){return function($p3){return new Fay$$$(function(){var to = $p3;var th = $p2;var fr = $p1;return Fay$$_(Fay$$_(Fay$$_(Prelude.enumFromByTo)(fr))(Fay$$_(Fay$$_(Fay$$sub)(th))(fr)))(to);});};};};Prelude.fromIntegral = function($p1){return new Fay$$$(function(){return $p1;});};Prelude.fromInteger = function($p1){return new Fay$$$(function(){return $p1;});};Prelude.not = function($p1){return new Fay$$$(function(){var p = $p1;return Fay$$_(p) ? false : true;});};Prelude.otherwise = true;Prelude.show = function($p1){return new Fay$$$(function(){return Fay$$jsToFay_string(JSON.stringify(Fay$$fayToJs([\"automatic\"],$p1)));});};Prelude.error = function($p1){return new Fay$$$(function(){return Fay$$jsToFay([\"unknown\"],(function() { throw Fay$$fayToJs_string($p1) })());});};Prelude.$_undefined = new Fay$$$(function(){return Fay$$_(Prelude.error)(Fay$$list(\"Prelude.undefined\"));});Prelude.either = function($p1){return function($p2){return function($p3){return new Fay$$$(function(){if (Fay$$_($p3) instanceof Prelude._Left) {var a = Fay$$_($p3).slot1;var f = $p1;return Fay$$_(f)(a);}if (Fay$$_($p3) instanceof Prelude._Right) {var b = Fay$$_($p3).slot1;var g = $p2;return Fay$$_(g)(b);}throw [\"unhandled case in either\",[$p1,$p2,$p3]];});};};};Prelude.until = function($p1){return function($p2){return function($p3){return new Fay$$$(function(){var x = $p3;var f = $p2;var p = $p1;return Fay$$_(Fay$$_(p)(x)) ? x : Fay$$_(Fay$$_(Fay$$_(Prelude.until)(p))(f))(Fay$$_(f)(x));});};};};Prelude.$36$$33$ = function($p1){return function($p2){return new Fay$$$(function(){var x = $p2;var f = $p1;return Fay$$_(Fay$$_(Fay$$seq)(x))(Fay$$_(f)(x));});};};Prelude.$_const = function($p1){return function($p2){return new Fay$$$(function(){var a = $p1;return a;});};};Prelude.id = function($p1){return new Fay$$$(function(){var x = $p1;return x;});};Prelude.$46$ = function($p1){return function($p2){return function($p3){return new Fay$$$(function(){var x = $p3;var g = $p2;var f = $p1;return Fay$$_(f)(Fay$$_(g)(x));});};};};Prelude.$36$ = function($p1){return function($p2){return new Fay$$$(function(){var x = $p2;var f = $p1;return Fay$$_(f)(x);});};};Prelude.flip = function($p1){return function($p2){return function($p3){return new Fay$$$(function(){var y = $p3;var x = $p2;var f = $p1;return Fay$$_(Fay$$_(f)(y))(x);});};};};Prelude.curry = function($p1){return function($p2){return function($p3){return new Fay$$$(function(){var y = $p3;var x = $p2;var f = $p1;return Fay$$_(f)(Fay$$list([x,y]));});};};};Prelude.uncurry = function($p1){return function($p2){return new Fay$$$(function(){var p = $p2;var f = $p1;return (function($tmp1){if (Fay$$listLen(Fay$$_($tmp1),2)) {var x = Fay$$index(0,Fay$$_($tmp1));var y = Fay$$index(1,Fay$$_($tmp1));return Fay$$_(Fay$$_(f)(x))(y);}return (function(){ throw ([\"unhandled case\",$tmp1]); })();})(p);});};};Prelude.snd = function($p1){return new Fay$$$(function(){if (Fay$$listLen(Fay$$_($p1),2)) {var x = Fay$$index(1,Fay$$_($p1));return x;}throw [\"unhandled case in snd\",[$p1]];});};Prelude.fst = function($p1){return new Fay$$$(function(){if (Fay$$listLen(Fay$$_($p1),2)) {var x = Fay$$index(0,Fay$$_($p1));return x;}throw [\"unhandled case in fst\",[$p1]];});};Prelude.div = function($p1){return function($p2){return new Fay$$$(function(){var y = $p2;var x = $p1;if (Fay$$_(Fay$$_(Fay$$_(Fay$$and)(Fay$$_(Fay$$_(Fay$$gt)(x))(0)))(Fay$$_(Fay$$_(Fay$$lt)(y))(0)))) {return Fay$$_(Fay$$_(Fay$$sub)(Fay$$_(Fay$$_(Prelude.quot)(Fay$$_(Fay$$_(Fay$$sub)(x))(1)))(y)))(1);} else {if (Fay$$_(Fay$$_(Fay$$_(Fay$$and)(Fay$$_(Fay$$_(Fay$$lt)(x))(0)))(Fay$$_(Fay$$_(Fay$$gt)(y))(0)))) {return Fay$$_(Fay$$_(Fay$$sub)(Fay$$_(Fay$$_(Prelude.quot)(Fay$$_(Fay$$_(Fay$$add)(x))(1)))(y)))(1);}}var y = $p2;var x = $p1;return Fay$$_(Fay$$_(Prelude.quot)(x))(y);});};};Prelude.mod = function($p1){return function($p2){return new Fay$$$(function(){var y = $p2;var x = $p1;if (Fay$$_(Fay$$_(Fay$$_(Fay$$and)(Fay$$_(Fay$$_(Fay$$gt)(x))(0)))(Fay$$_(Fay$$_(Fay$$lt)(y))(0)))) {return Fay$$_(Fay$$_(Fay$$add)(Fay$$_(Fay$$_(Fay$$add)(Fay$$_(Fay$$_(Prelude.rem)(Fay$$_(Fay$$_(Fay$$sub)(x))(1)))(y)))(y)))(1);} else {if (Fay$$_(Fay$$_(Fay$$_(Fay$$and)(Fay$$_(Fay$$_(Fay$$lt)(x))(0)))(Fay$$_(Fay$$_(Fay$$gt)(y))(0)))) {return Fay$$_(Fay$$_(Fay$$sub)(Fay$$_(Fay$$_(Fay$$add)(Fay$$_(Fay$$_(Prelude.rem)(Fay$$_(Fay$$_(Fay$$add)(x))(1)))(y)))(y)))(1);}}var y = $p2;var x = $p1;return Fay$$_(Fay$$_(Prelude.rem)(x))(y);});};};Prelude.divMod = function($p1){return function($p2){return new Fay$$$(function(){var y = $p2;var x = $p1;if (Fay$$_(Fay$$_(Fay$$_(Fay$$and)(Fay$$_(Fay$$_(Fay$$gt)(x))(0)))(Fay$$_(Fay$$_(Fay$$lt)(y))(0)))) {return (function($tmp1){if (Fay$$listLen(Fay$$_($tmp1),2)) {var q = Fay$$index(0,Fay$$_($tmp1));var r = Fay$$index(1,Fay$$_($tmp1));return Fay$$list([Fay$$_(Fay$$_(Fay$$sub)(q))(1),Fay$$_(Fay$$_(Fay$$add)(Fay$$_(Fay$$_(Fay$$add)(r))(y)))(1)]);}return (function(){ throw ([\"unhandled case\",$tmp1]); })();})(Fay$$_(Fay$$_(Prelude.quotRem)(Fay$$_(Fay$$_(Fay$$sub)(x))(1)))(y));} else {if (Fay$$_(Fay$$_(Fay$$_(Fay$$and)(Fay$$_(Fay$$_(Fay$$lt)(x))(0)))(Fay$$_(Fay$$_(Fay$$gt)(y))(1)))) {return (function($tmp1){if (Fay$$listLen(Fay$$_($tmp1),2)) {var q = Fay$$index(0,Fay$$_($tmp1));var r = Fay$$index(1,Fay$$_($tmp1));return Fay$$list([Fay$$_(Fay$$_(Fay$$sub)(q))(1),Fay$$_(Fay$$_(Fay$$sub)(Fay$$_(Fay$$_(Fay$$add)(r))(y)))(1)]);}return (function(){ throw ([\"unhandled case\",$tmp1]); })();})(Fay$$_(Fay$$_(Prelude.quotRem)(Fay$$_(Fay$$_(Fay$$add)(x))(1)))(y));}}var y = $p2;var x = $p1;return Fay$$_(Fay$$_(Prelude.quotRem)(x))(y);});};};Prelude.min = function($p1){return function($p2){return new Fay$$$(function(){return Fay$$jsToFay([\"unknown\"],Math.min(Fay$$_(Fay$$fayToJs([\"unknown\"],$p1)),Fay$$_(Fay$$fayToJs([\"unknown\"],$p2))));});};};Prelude.max = function($p1){return function($p2){return new Fay$$$(function(){return Fay$$jsToFay([\"unknown\"],Math.max(Fay$$_(Fay$$fayToJs([\"unknown\"],$p1)),Fay$$_(Fay$$fayToJs([\"unknown\"],$p2))));});};};Prelude.recip = function($p1){return new Fay$$$(function(){var x = $p1;return Fay$$_(Fay$$_(Fay$$divi)(1))(x);});};Prelude.negate = function($p1){return new Fay$$$(function(){var x = $p1;return (-(Fay$$_(x)));});};Prelude.abs = function($p1){return new Fay$$$(function(){var x = $p1;return Fay$$_(Fay$$_(Fay$$_(Fay$$lt)(x))(0)) ? Fay$$_(Prelude.negate)(x) : x;});};Prelude.signum = function($p1){return new Fay$$$(function(){var x = $p1;return Fay$$_(Fay$$_(Fay$$_(Fay$$gt)(x))(0)) ? 1 : Fay$$_(Fay$$_(Fay$$_(Fay$$eq)(x))(0)) ? 0 : (-(1));});};Prelude.pi = new Fay$$$(function(){return Fay$$jsToFay_double(Math.PI);});Prelude.exp = function($p1){return new Fay$$$(function(){return Fay$$jsToFay_double(Math.exp(Fay$$fayToJs_double($p1)));});};Prelude.sqrt = function($p1){return new Fay$$$(function(){return Fay$$jsToFay_double(Math.sqrt(Fay$$fayToJs_double($p1)));});};Prelude.log = function($p1){return new Fay$$$(function(){return Fay$$jsToFay_double(Math.log(Fay$$fayToJs_double($p1)));});};Prelude.$42$$42$ = new Fay$$$(function(){return Prelude.unsafePow;});Prelude.$94$$94$ = new Fay$$$(function(){return Prelude.unsafePow;});Prelude.unsafePow = function($p1){return function($p2){return new Fay$$$(function(){return Fay$$jsToFay([\"unknown\"],Math.pow(Fay$$_(Fay$$fayToJs([\"unknown\"],$p1)),Fay$$_(Fay$$fayToJs([\"unknown\"],$p2))));});};};Prelude.$94$ = function($p1){return function($p2){return new Fay$$$(function(){var b = $p2;var a = $p1;if (Fay$$_(Fay$$_(Fay$$_(Fay$$lt)(b))(0))) {return Fay$$_(Prelude.error)(Fay$$list(\"(^): negative exponent\"));} else {if (Fay$$_(Fay$$_(Fay$$_(Fay$$eq)(b))(0))) {return 1;} else {if (Fay$$_(Fay$$_(Prelude.even)(b))) {return (function(){return new Fay$$$(function(){var x = new Fay$$$(function(){return Fay$$_(Fay$$_(Prelude.$94$)(a))(Fay$$_(Fay$$_(Prelude.quot)(b))(2));});return Fay$$_(Fay$$_(Fay$$mult)(x))(x);});})();}}}var b = $p2;var a = $p1;return Fay$$_(Fay$$_(Fay$$mult)(a))(Fay$$_(Fay$$_(Prelude.$94$)(a))(Fay$$_(Fay$$_(Fay$$sub)(b))(1)));});};};Prelude.logBase = function($p1){return function($p2){return new Fay$$$(function(){var x = $p2;var b = $p1;return Fay$$_(Fay$$_(Fay$$divi)(Fay$$_(Prelude.log)(x)))(Fay$$_(Prelude.log)(b));});};};Prelude.sin = function($p1){return new Fay$$$(function(){return Fay$$jsToFay_double(Math.sin(Fay$$fayToJs_double($p1)));});};Prelude.tan = function($p1){return new Fay$$$(function(){return Fay$$jsToFay_double(Math.tan(Fay$$fayToJs_double($p1)));});};Prelude.cos = function($p1){return new Fay$$$(function(){return Fay$$jsToFay_double(Math.cos(Fay$$fayToJs_double($p1)));});};Prelude.asin = function($p1){return new Fay$$$(function(){return Fay$$jsToFay_double(Math.asin(Fay$$fayToJs_double($p1)));});};Prelude.atan = function($p1){return new Fay$$$(function(){return Fay$$jsToFay_double(Math.atan(Fay$$fayToJs_double($p1)));});};Prelude.acos = function($p1){return new Fay$$$(function(){return Fay$$jsToFay_double(Math.acos(Fay$$fayToJs_double($p1)));});};Prelude.sinh = function($p1){return new Fay$$$(function(){var x = $p1;return Fay$$_(Fay$$_(Fay$$divi)(Fay$$_(Fay$$_(Fay$$sub)(Fay$$_(Prelude.exp)(x)))(Fay$$_(Prelude.exp)((-(Fay$$_(x)))))))(2);});};Prelude.tanh = function($p1){return new Fay$$$(function(){var x = $p1;return (function(){return new Fay$$$(function(){var a = new Fay$$$(function(){return Fay$$_(Prelude.exp)(x);});var b = new Fay$$$(function(){return Fay$$_(Prelude.exp)((-(Fay$$_(x))));});return Fay$$_(Fay$$_(Fay$$divi)(Fay$$_(Fay$$_(Fay$$sub)(a))(b)))(Fay$$_(Fay$$_(Fay$$add)(a))(b));});})();});};Prelude.cosh = function($p1){return new Fay$$$(function(){var x = $p1;return Fay$$_(Fay$$_(Fay$$divi)(Fay$$_(Fay$$_(Fay$$add)(Fay$$_(Prelude.exp)(x)))(Fay$$_(Prelude.exp)((-(Fay$$_(x)))))))(2);});};Prelude.asinh = function($p1){return new Fay$$$(function(){var x = $p1;return Fay$$_(Prelude.log)(Fay$$_(Fay$$_(Fay$$add)(x))(Fay$$_(Prelude.sqrt)(Fay$$_(Fay$$_(Fay$$add)(Fay$$_(Fay$$_(Prelude.$42$$42$)(x))(2)))(1))));});};Prelude.atanh = function($p1){return new Fay$$$(function(){var x = $p1;return Fay$$_(Fay$$_(Fay$$divi)(Fay$$_(Prelude.log)(Fay$$_(Fay$$_(Fay$$divi)(Fay$$_(Fay$$_(Fay$$add)(1))(x)))(Fay$$_(Fay$$_(Fay$$sub)(1))(x)))))(2);});};Prelude.acosh = function($p1){return new Fay$$$(function(){var x = $p1;return Fay$$_(Prelude.log)(Fay$$_(Fay$$_(Fay$$add)(x))(Fay$$_(Prelude.sqrt)(Fay$$_(Fay$$_(Fay$$sub)(Fay$$_(Fay$$_(Prelude.$42$$42$)(x))(2)))(1))));});};Prelude.properFraction = function($p1){return new Fay$$$(function(){var x = $p1;return (function(){return new Fay$$$(function(){var a = new Fay$$$(function(){return Fay$$_(Prelude.truncate)(x);});return Fay$$list([a,Fay$$_(Fay$$_(Fay$$sub)(x))(Fay$$_(Prelude.fromIntegral)(a))]);});})();});};Prelude.truncate = function($p1){return new Fay$$$(function(){var x = $p1;return Fay$$_(Fay$$_(Fay$$_(Fay$$lt)(x))(0)) ? Fay$$_(Prelude.ceiling)(x) : Fay$$_(Prelude.floor)(x);});};Prelude.round = function($p1){return new Fay$$$(function(){return Fay$$jsToFay_int(Math.round(Fay$$fayToJs_double($p1)));});};Prelude.ceiling = function($p1){return new Fay$$$(function(){return Fay$$jsToFay_int(Math.ceil(Fay$$fayToJs_double($p1)));});};Prelude.floor = function($p1){return new Fay$$$(function(){return Fay$$jsToFay_int(Math.floor(Fay$$fayToJs_double($p1)));});};Prelude.subtract = new Fay$$$(function(){return Fay$$_(Prelude.flip)(Fay$$sub);});Prelude.even = function($p1){return new Fay$$$(function(){var x = $p1;return Fay$$_(Fay$$_(Fay$$eq)(Fay$$_(Fay$$_(Prelude.rem)(x))(2)))(0);});};Prelude.odd = function($p1){return new Fay$$$(function(){var x = $p1;return Fay$$_(Prelude.not)(Fay$$_(Prelude.even)(x));});};Prelude.gcd = function($p1){return function($p2){return new Fay$$$(function(){var b = $p2;var a = $p1;return (function(){var go = function($p1){return function($p2){return new Fay$$$(function(){if (Fay$$_($p2) === 0) {var x = $p1;return x;}var y = $p2;var x = $p1;return Fay$$_(Fay$$_(go)(y))(Fay$$_(Fay$$_(Prelude.rem)(x))(y));});};};return Fay$$_(Fay$$_(go)(Fay$$_(Prelude.abs)(a)))(Fay$$_(Prelude.abs)(b));})();});};};Prelude.quot = function($p1){return function($p2){return new Fay$$$(function(){var y = $p2;var x = $p1;return Fay$$_(Fay$$_(Fay$$_(Fay$$eq)(y))(0)) ? Fay$$_(Prelude.error)(Fay$$list(\"Division by zero\")) : Fay$$_(Fay$$_(Prelude.quot$39$)(x))(y);});};};Prelude.quot$39$ = function($p1){return function($p2){return new Fay$$$(function(){return Fay$$jsToFay_int(~~(Fay$$fayToJs_int($p1)/Fay$$fayToJs_int($p2)));});};};Prelude.quotRem = function($p1){return function($p2){return new Fay$$$(function(){var y = $p2;var x = $p1;return Fay$$list([Fay$$_(Fay$$_(Prelude.quot)(x))(y),Fay$$_(Fay$$_(Prelude.rem)(x))(y)]);});};};Prelude.rem = function($p1){return function($p2){return new Fay$$$(function(){var y = $p2;var x = $p1;return Fay$$_(Fay$$_(Fay$$_(Fay$$eq)(y))(0)) ? Fay$$_(Prelude.error)(Fay$$list(\"Division by zero\")) : Fay$$_(Fay$$_(Prelude.rem$39$)(x))(y);});};};Prelude.rem$39$ = function($p1){return function($p2){return new Fay$$$(function(){return Fay$$jsToFay_int(Fay$$fayToJs_int($p1) % Fay$$fayToJs_int($p2));});};};Prelude.lcm = function($p1){return function($p2){return new Fay$$$(function(){if (Fay$$_($p2) === 0) {return 0;}if (Fay$$_($p1) === 0) {return 0;}var b = $p2;var a = $p1;return Fay$$_(Prelude.abs)(Fay$$_(Fay$$_(Fay$$mult)(Fay$$_(Fay$$_(Prelude.quot)(a))(Fay$$_(Fay$$_(Prelude.gcd)(a))(b))))(b));});};};Prelude.find = function($p1){return function($p2){return new Fay$$$(function(){var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var p = $p1;return Fay$$_(Fay$$_(p)(x)) ? Fay$$_(Prelude.Just)(x) : Fay$$_(Fay$$_(Prelude.find)(p))(xs);}if (Fay$$_($p2) === null) {return Prelude.Nothing;}throw [\"unhandled case in find\",[$p1,$p2]];});};};Prelude.filter = function($p1){return function($p2){return new Fay$$$(function(){var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var p = $p1;return Fay$$_(Fay$$_(p)(x)) ? Fay$$_(Fay$$_(Fay$$cons)(x))(Fay$$_(Fay$$_(Prelude.filter)(p))(xs)) : Fay$$_(Fay$$_(Prelude.filter)(p))(xs);}if (Fay$$_($p2) === null) {return null;}throw [\"unhandled case in filter\",[$p1,$p2]];});};};Prelude.$_null = function($p1){return new Fay$$$(function(){if (Fay$$_($p1) === null) {return true;}return false;});};Prelude.map = function($p1){return function($p2){return new Fay$$$(function(){if (Fay$$_($p2) === null) {return null;}var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var f = $p1;return Fay$$_(Fay$$_(Fay$$cons)(Fay$$_(f)(x)))(Fay$$_(Fay$$_(Prelude.map)(f))(xs));}throw [\"unhandled case in map\",[$p1,$p2]];});};};Prelude.nub = function($p1){return new Fay$$$(function(){var ls = $p1;return Fay$$_(Fay$$_(Prelude.nub$39$)(ls))(null);});};Prelude.nub$39$ = function($p1){return function($p2){return new Fay$$$(function(){if (Fay$$_($p1) === null) {return null;}var ls = $p2;var $tmp1 = Fay$$_($p1);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;return Fay$$_(Fay$$_(Fay$$_(Prelude.elem)(x))(ls)) ? Fay$$_(Fay$$_(Prelude.nub$39$)(xs))(ls) : Fay$$_(Fay$$_(Fay$$cons)(x))(Fay$$_(Fay$$_(Prelude.nub$39$)(xs))(Fay$$_(Fay$$_(Fay$$cons)(x))(ls)));}throw [\"unhandled case in nub'\",[$p1,$p2]];});};};Prelude.elem = function($p1){return function($p2){return new Fay$$$(function(){var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var y = $tmp1.car;var ys = $tmp1.cdr;var x = $p1;return Fay$$_(Fay$$_(Fay$$or)(Fay$$_(Fay$$_(Fay$$eq)(x))(y)))(Fay$$_(Fay$$_(Prelude.elem)(x))(ys));}if (Fay$$_($p2) === null) {return false;}throw [\"unhandled case in elem\",[$p1,$p2]];});};};Prelude.notElem = function($p1){return function($p2){return new Fay$$$(function(){var ys = $p2;var x = $p1;return Fay$$_(Prelude.not)(Fay$$_(Fay$$_(Prelude.elem)(x))(ys));});};};Prelude.sort = new Fay$$$(function(){return Fay$$_(Prelude.sortBy)(Prelude.compare);});Prelude.sortBy = function($p1){return new Fay$$$(function(){var cmp = $p1;return Fay$$_(Fay$$_(Prelude.foldr)(Fay$$_(Prelude.insertBy)(cmp)))(null);});};Prelude.insertBy = function($p1){return function($p2){return function($p3){return new Fay$$$(function(){if (Fay$$_($p3) === null) {var x = $p2;return Fay$$list([x]);}var ys = $p3;var x = $p2;var cmp = $p1;return (function($tmp1){if (Fay$$_($tmp1) === null) {return Fay$$list([x]);}var $tmp2 = Fay$$_($tmp1);if ($tmp2 instanceof Fay$$Cons) {var y = $tmp2.car;var ys$39$ = $tmp2.cdr;return (function($tmp2){if (Fay$$_($tmp2) instanceof Prelude._GT) {return Fay$$_(Fay$$_(Fay$$cons)(y))(Fay$$_(Fay$$_(Fay$$_(Prelude.insertBy)(cmp))(x))(ys$39$));}return Fay$$_(Fay$$_(Fay$$cons)(x))(ys);})(Fay$$_(Fay$$_(cmp)(x))(y));}return (function(){ throw ([\"unhandled case\",$tmp1]); })();})(ys);});};};};Prelude.conc = function($p1){return function($p2){return new Fay$$$(function(){var ys = $p2;var $tmp1 = Fay$$_($p1);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;return Fay$$_(Fay$$_(Fay$$cons)(x))(Fay$$_(Fay$$_(Prelude.conc)(xs))(ys));}var ys = $p2;if (Fay$$_($p1) === null) {return ys;}throw [\"unhandled case in conc\",[$p1,$p2]];});};};Prelude.concat = new Fay$$$(function(){return Fay$$_(Fay$$_(Prelude.foldr)(Prelude.conc))(null);});Prelude.concatMap = function($p1){return new Fay$$$(function(){var f = $p1;return Fay$$_(Fay$$_(Prelude.foldr)(Fay$$_(Fay$$_(Prelude.$46$)(Prelude.$43$$43$))(f)))(null);});};Prelude.foldr = function($p1){return function($p2){return function($p3){return new Fay$$$(function(){if (Fay$$_($p3) === null) {var z = $p2;return z;}var $tmp1 = Fay$$_($p3);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var z = $p2;var f = $p1;return Fay$$_(Fay$$_(f)(x))(Fay$$_(Fay$$_(Fay$$_(Prelude.foldr)(f))(z))(xs));}throw [\"unhandled case in foldr\",[$p1,$p2,$p3]];});};};};Prelude.foldr1 = function($p1){return function($p2){return new Fay$$$(function(){if (Fay$$listLen(Fay$$_($p2),1)) {var x = Fay$$index(0,Fay$$_($p2));return x;}var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var f = $p1;return Fay$$_(Fay$$_(f)(x))(Fay$$_(Fay$$_(Prelude.foldr1)(f))(xs));}if (Fay$$_($p2) === null) {return Fay$$_(Prelude.error)(Fay$$list(\"foldr1: empty list\"));}throw [\"unhandled case in foldr1\",[$p1,$p2]];});};};Prelude.foldl = function($p1){return function($p2){return function($p3){return new Fay$$$(function(){if (Fay$$_($p3) === null) {var z = $p2;return z;}var $tmp1 = Fay$$_($p3);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var z = $p2;var f = $p1;return Fay$$_(Fay$$_(Fay$$_(Prelude.foldl)(f))(Fay$$_(Fay$$_(f)(z))(x)))(xs);}throw [\"unhandled case in foldl\",[$p1,$p2,$p3]];});};};};Prelude.foldl1 = function($p1){return function($p2){return new Fay$$$(function(){var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var f = $p1;return Fay$$_(Fay$$_(Fay$$_(Prelude.foldl)(f))(x))(xs);}if (Fay$$_($p2) === null) {return Fay$$_(Prelude.error)(Fay$$list(\"foldl1: empty list\"));}throw [\"unhandled case in foldl1\",[$p1,$p2]];});};};Prelude.$43$$43$ = function($p1){return function($p2){return new Fay$$$(function(){var y = $p2;var x = $p1;return Fay$$_(Fay$$_(Prelude.conc)(x))(y);});};};Prelude.$33$$33$ = function($p1){return function($p2){return new Fay$$$(function(){var b = $p2;var a = $p1;return (function(){var go = function($p1){return function($p2){return new Fay$$$(function(){if (Fay$$_($p1) === null) {return Fay$$_(Prelude.error)(Fay$$list(\"(!!): index too large\"));}if (Fay$$_($p2) === 0) {var $tmp1 = Fay$$_($p1);if ($tmp1 instanceof Fay$$Cons) {var h = $tmp1.car;return h;}}var n = $p2;var $tmp1 = Fay$$_($p1);if ($tmp1 instanceof Fay$$Cons) {var t = $tmp1.cdr;return Fay$$_(Fay$$_(go)(t))(Fay$$_(Fay$$_(Fay$$sub)(n))(1));}throw [\"unhandled case in go\",[$p1,$p2]];});};};return Fay$$_(Fay$$_(Fay$$_(Fay$$lt)(b))(0)) ? Fay$$_(Prelude.error)(Fay$$list(\"(!!): negative index\")) : Fay$$_(Fay$$_(go)(a))(b);})();});};};Prelude.head = function($p1){return new Fay$$$(function(){if (Fay$$_($p1) === null) {return Fay$$_(Prelude.error)(Fay$$list(\"head: empty list\"));}var $tmp1 = Fay$$_($p1);if ($tmp1 instanceof Fay$$Cons) {var h = $tmp1.car;return h;}throw [\"unhandled case in head\",[$p1]];});};Prelude.tail = function($p1){return new Fay$$$(function(){if (Fay$$_($p1) === null) {return Fay$$_(Prelude.error)(Fay$$list(\"tail: empty list\"));}var $tmp1 = Fay$$_($p1);if ($tmp1 instanceof Fay$$Cons) {var t = $tmp1.cdr;return t;}throw [\"unhandled case in tail\",[$p1]];});};Prelude.init = function($p1){return new Fay$$$(function(){if (Fay$$_($p1) === null) {return Fay$$_(Prelude.error)(Fay$$list(\"init: empty list\"));}if (Fay$$listLen(Fay$$_($p1),1)) {return null;}var $tmp1 = Fay$$_($p1);if ($tmp1 instanceof Fay$$Cons) {var h = $tmp1.car;var t = $tmp1.cdr;return Fay$$_(Fay$$_(Fay$$cons)(h))(Fay$$_(Prelude.init)(t));}throw [\"unhandled case in init\",[$p1]];});};Prelude.last = function($p1){return new Fay$$$(function(){if (Fay$$_($p1) === null) {return Fay$$_(Prelude.error)(Fay$$list(\"last: empty list\"));}if (Fay$$listLen(Fay$$_($p1),1)) {var a = Fay$$index(0,Fay$$_($p1));return a;}var $tmp1 = Fay$$_($p1);if ($tmp1 instanceof Fay$$Cons) {var t = $tmp1.cdr;return Fay$$_(Prelude.last)(t);}throw [\"unhandled case in last\",[$p1]];});};Prelude.iterate = function($p1){return function($p2){return new Fay$$$(function(){var x = $p2;var f = $p1;return Fay$$_(Fay$$_(Fay$$cons)(x))(Fay$$_(Fay$$_(Prelude.iterate)(f))(Fay$$_(f)(x)));});};};Prelude.repeat = function($p1){return new Fay$$$(function(){var x = $p1;return Fay$$_(Fay$$_(Fay$$cons)(x))(Fay$$_(Prelude.repeat)(x));});};Prelude.replicate = function($p1){return function($p2){return new Fay$$$(function(){if (Fay$$_($p1) === 0) {return null;}var x = $p2;var n = $p1;return Fay$$_(Fay$$_(Fay$$_(Fay$$lt)(n))(0)) ? null : Fay$$_(Fay$$_(Fay$$cons)(x))(Fay$$_(Fay$$_(Prelude.replicate)(Fay$$_(Fay$$_(Fay$$sub)(n))(1)))(x));});};};Prelude.cycle = function($p1){return new Fay$$$(function(){if (Fay$$_($p1) === null) {return Fay$$_(Prelude.error)(Fay$$list(\"cycle: empty list\"));}var xs = $p1;return (function(){var xs$39$ = new Fay$$$(function(){return Fay$$_(Fay$$_(Prelude.$43$$43$)(xs))(xs$39$);});return xs$39$;})();});};Prelude.take = function($p1){return function($p2){return new Fay$$$(function(){if (Fay$$_($p1) === 0) {return null;}if (Fay$$_($p2) === null) {return null;}var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var n = $p1;return Fay$$_(Fay$$_(Fay$$_(Fay$$lt)(n))(0)) ? null : Fay$$_(Fay$$_(Fay$$cons)(x))(Fay$$_(Fay$$_(Prelude.take)(Fay$$_(Fay$$_(Fay$$sub)(n))(1)))(xs));}throw [\"unhandled case in take\",[$p1,$p2]];});};};Prelude.drop = function($p1){return function($p2){return new Fay$$$(function(){var xs = $p2;if (Fay$$_($p1) === 0) {return xs;}if (Fay$$_($p2) === null) {return null;}var xss = $p2;var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var xs = $tmp1.cdr;var n = $p1;return Fay$$_(Fay$$_(Fay$$_(Fay$$lt)(n))(0)) ? xss : Fay$$_(Fay$$_(Prelude.drop)(Fay$$_(Fay$$_(Fay$$sub)(n))(1)))(xs);}throw [\"unhandled case in drop\",[$p1,$p2]];});};};Prelude.splitAt = function($p1){return function($p2){return new Fay$$$(function(){var xs = $p2;if (Fay$$_($p1) === 0) {return Fay$$list([null,xs]);}if (Fay$$_($p2) === null) {return Fay$$list([null,null]);}var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var n = $p1;return Fay$$_(Fay$$_(Fay$$_(Fay$$lt)(n))(0)) ? Fay$$list([null,Fay$$_(Fay$$_(Fay$$cons)(x))(xs)]) : (function($tmp1){if (Fay$$listLen(Fay$$_($tmp1),2)) {var a = Fay$$index(0,Fay$$_($tmp1));var b = Fay$$index(1,Fay$$_($tmp1));return Fay$$list([Fay$$_(Fay$$_(Fay$$cons)(x))(a),b]);}return (function(){ throw ([\"unhandled case\",$tmp1]); })();})(Fay$$_(Fay$$_(Prelude.splitAt)(Fay$$_(Fay$$_(Fay$$sub)(n))(1)))(xs));}throw [\"unhandled case in splitAt\",[$p1,$p2]];});};};Prelude.takeWhile = function($p1){return function($p2){return new Fay$$$(function(){if (Fay$$_($p2) === null) {return null;}var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var p = $p1;return Fay$$_(Fay$$_(p)(x)) ? Fay$$_(Fay$$_(Fay$$cons)(x))(Fay$$_(Fay$$_(Prelude.takeWhile)(p))(xs)) : null;}throw [\"unhandled case in takeWhile\",[$p1,$p2]];});};};Prelude.dropWhile = function($p1){return function($p2){return new Fay$$$(function(){if (Fay$$_($p2) === null) {return null;}var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var p = $p1;return Fay$$_(Fay$$_(p)(x)) ? Fay$$_(Fay$$_(Prelude.dropWhile)(p))(xs) : Fay$$_(Fay$$_(Fay$$cons)(x))(xs);}throw [\"unhandled case in dropWhile\",[$p1,$p2]];});};};Prelude.span = function($p1){return function($p2){return new Fay$$$(function(){if (Fay$$_($p2) === null) {return Fay$$list([null,null]);}var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var p = $p1;return Fay$$_(Fay$$_(p)(x)) ? (function($tmp1){if (Fay$$listLen(Fay$$_($tmp1),2)) {var a = Fay$$index(0,Fay$$_($tmp1));var b = Fay$$index(1,Fay$$_($tmp1));return Fay$$list([Fay$$_(Fay$$_(Fay$$cons)(x))(a),b]);}return (function(){ throw ([\"unhandled case\",$tmp1]); })();})(Fay$$_(Fay$$_(Prelude.span)(p))(xs)) : Fay$$list([null,Fay$$_(Fay$$_(Fay$$cons)(x))(xs)]);}throw [\"unhandled case in span\",[$p1,$p2]];});};};Prelude.$_break = function($p1){return new Fay$$$(function(){var p = $p1;return Fay$$_(Prelude.span)(Fay$$_(Fay$$_(Prelude.$46$)(Prelude.not))(p));});};Prelude.zipWith = function($p1){return function($p2){return function($p3){return new Fay$$$(function(){var $tmp1 = Fay$$_($p3);if ($tmp1 instanceof Fay$$Cons) {var b = $tmp1.car;var bs = $tmp1.cdr;var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var a = $tmp1.car;var as = $tmp1.cdr;var f = $p1;return Fay$$_(Fay$$_(Fay$$cons)(Fay$$_(Fay$$_(f)(a))(b)))(Fay$$_(Fay$$_(Fay$$_(Prelude.zipWith)(f))(as))(bs));}}return null;});};};};Prelude.zipWith3 = function($p1){return function($p2){return function($p3){return function($p4){return new Fay$$$(function(){var $tmp1 = Fay$$_($p4);if ($tmp1 instanceof Fay$$Cons) {var c = $tmp1.car;var cs = $tmp1.cdr;var $tmp1 = Fay$$_($p3);if ($tmp1 instanceof Fay$$Cons) {var b = $tmp1.car;var bs = $tmp1.cdr;var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var a = $tmp1.car;var as = $tmp1.cdr;var f = $p1;return Fay$$_(Fay$$_(Fay$$cons)(Fay$$_(Fay$$_(Fay$$_(f)(a))(b))(c)))(Fay$$_(Fay$$_(Fay$$_(Fay$$_(Prelude.zipWith3)(f))(as))(bs))(cs));}}}return null;});};};};};Prelude.zip = function($p1){return function($p2){return new Fay$$$(function(){var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var b = $tmp1.car;var bs = $tmp1.cdr;var $tmp1 = Fay$$_($p1);if ($tmp1 instanceof Fay$$Cons) {var a = $tmp1.car;var as = $tmp1.cdr;return Fay$$_(Fay$$_(Fay$$cons)(Fay$$list([a,b])))(Fay$$_(Fay$$_(Prelude.zip)(as))(bs));}}return null;});};};Prelude.zip3 = function($p1){return function($p2){return function($p3){return new Fay$$$(function(){var $tmp1 = Fay$$_($p3);if ($tmp1 instanceof Fay$$Cons) {var c = $tmp1.car;var cs = $tmp1.cdr;var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var b = $tmp1.car;var bs = $tmp1.cdr;var $tmp1 = Fay$$_($p1);if ($tmp1 instanceof Fay$$Cons) {var a = $tmp1.car;var as = $tmp1.cdr;return Fay$$_(Fay$$_(Fay$$cons)(Fay$$list([a,b,c])))(Fay$$_(Fay$$_(Fay$$_(Prelude.zip3)(as))(bs))(cs));}}}return null;});};};};Prelude.unzip = function($p1){return new Fay$$$(function(){var $tmp1 = Fay$$_($p1);if ($tmp1 instanceof Fay$$Cons) {if (Fay$$listLen(Fay$$_($tmp1.car),2)) {var x = Fay$$index(0,Fay$$_($tmp1.car));var y = Fay$$index(1,Fay$$_($tmp1.car));var ps = $tmp1.cdr;return (function($tmp1){if (Fay$$listLen(Fay$$_($tmp1),2)) {var xs = Fay$$index(0,Fay$$_($tmp1));var ys = Fay$$index(1,Fay$$_($tmp1));return Fay$$list([Fay$$_(Fay$$_(Fay$$cons)(x))(xs),Fay$$_(Fay$$_(Fay$$cons)(y))(ys)]);}return (function(){ throw ([\"unhandled case\",$tmp1]); })();})(Fay$$_(Prelude.unzip)(ps));}}if (Fay$$_($p1) === null) {return Fay$$list([null,null]);}throw [\"unhandled case in unzip\",[$p1]];});};Prelude.unzip3 = function($p1){return new Fay$$$(function(){var $tmp1 = Fay$$_($p1);if ($tmp1 instanceof Fay$$Cons) {if (Fay$$listLen(Fay$$_($tmp1.car),3)) {var x = Fay$$index(0,Fay$$_($tmp1.car));var y = Fay$$index(1,Fay$$_($tmp1.car));var z = Fay$$index(2,Fay$$_($tmp1.car));var ps = $tmp1.cdr;return (function($tmp1){if (Fay$$listLen(Fay$$_($tmp1),3)) {var xs = Fay$$index(0,Fay$$_($tmp1));var ys = Fay$$index(1,Fay$$_($tmp1));var zs = Fay$$index(2,Fay$$_($tmp1));return Fay$$list([Fay$$_(Fay$$_(Fay$$cons)(x))(xs),Fay$$_(Fay$$_(Fay$$cons)(y))(ys),Fay$$_(Fay$$_(Fay$$cons)(z))(zs)]);}return (function(){ throw ([\"unhandled case\",$tmp1]); })();})(Fay$$_(Prelude.unzip3)(ps));}}if (Fay$$_($p1) === null) {return Fay$$list([null,null,null]);}throw [\"unhandled case in unzip3\",[$p1]];});};Prelude.lines = function($p1){return new Fay$$$(function(){if (Fay$$_($p1) === null) {return null;}var s = $p1;return (function(){var isLineBreak = function($p1){return new Fay$$$(function(){var c = $p1;return Fay$$_(Fay$$_(Fay$$or)(Fay$$_(Fay$$_(Fay$$eq)(c))(\"\\r\")))(Fay$$_(Fay$$_(Fay$$eq)(c))(\"\\n\"));});};return (function($tmp1){if (Fay$$listLen(Fay$$_($tmp1),2)) {var a = Fay$$index(0,Fay$$_($tmp1));if (Fay$$_(Fay$$index(1,Fay$$_($tmp1))) === null) {return Fay$$list([a]);}}if (Fay$$listLen(Fay$$_($tmp1),2)) {var a = Fay$$index(0,Fay$$_($tmp1));var $tmp2 = Fay$$_(Fay$$index(1,Fay$$_($tmp1)));if ($tmp2 instanceof Fay$$Cons) {var cs = $tmp2.cdr;return Fay$$_(Fay$$_(Fay$$cons)(a))(Fay$$_(Prelude.lines)(cs));}}return (function(){ throw ([\"unhandled case\",$tmp1]); })();})(Fay$$_(Fay$$_(Prelude.$_break)(isLineBreak))(s));})();});};Prelude.unlines = function($p1){return new Fay$$$(function(){if (Fay$$_($p1) === null) {return null;}var $tmp1 = Fay$$_($p1);if ($tmp1 instanceof Fay$$Cons) {var l = $tmp1.car;var ls = $tmp1.cdr;return Fay$$_(Fay$$_(Prelude.$43$$43$)(l))(Fay$$_(Fay$$_(Fay$$cons)(\"\\n\"))(Fay$$_(Prelude.unlines)(ls)));}throw [\"unhandled case in unlines\",[$p1]];});};Prelude.words = function($p1){return new Fay$$$(function(){var str = $p1;return (function(){var words$39$ = function($p1){return new Fay$$$(function(){if (Fay$$_($p1) === null) {return null;}var s = $p1;return (function($tmp1){if (Fay$$listLen(Fay$$_($tmp1),2)) {var a = Fay$$index(0,Fay$$_($tmp1));var b = Fay$$index(1,Fay$$_($tmp1));return Fay$$_(Fay$$_(Fay$$cons)(a))(Fay$$_(Prelude.words)(b));}return (function(){ throw ([\"unhandled case\",$tmp1]); })();})(Fay$$_(Fay$$_(Prelude.$_break)(isSpace))(s));});};var isSpace = function($p1){return new Fay$$$(function(){var c = $p1;return Fay$$_(Fay$$_(Prelude.elem)(c))(Fay$$list(\" \\t\\r\\n\\u000c\\u000b\"));});};return Fay$$_(words$39$)(Fay$$_(Fay$$_(Prelude.dropWhile)(isSpace))(str));})();});};Prelude.unwords = new Fay$$$(function(){return Fay$$_(Prelude.intercalate)(Fay$$list(\" \"));});Prelude.and = function($p1){return new Fay$$$(function(){if (Fay$$_($p1) === null) {return true;}var $tmp1 = Fay$$_($p1);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;return Fay$$_(Fay$$_(Fay$$and)(x))(Fay$$_(Prelude.and)(xs));}throw [\"unhandled case in and\",[$p1]];});};Prelude.or = function($p1){return new Fay$$$(function(){if (Fay$$_($p1) === null) {return false;}var $tmp1 = Fay$$_($p1);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;return Fay$$_(Fay$$_(Fay$$or)(x))(Fay$$_(Prelude.or)(xs));}throw [\"unhandled case in or\",[$p1]];});};Prelude.any = function($p1){return function($p2){return new Fay$$$(function(){if (Fay$$_($p2) === null) {return false;}var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var p = $p1;return Fay$$_(Fay$$_(Fay$$or)(Fay$$_(p)(x)))(Fay$$_(Fay$$_(Prelude.any)(p))(xs));}throw [\"unhandled case in any\",[$p1,$p2]];});};};Prelude.all = function($p1){return function($p2){return new Fay$$$(function(){if (Fay$$_($p2) === null) {return true;}var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var p = $p1;return Fay$$_(Fay$$_(Fay$$and)(Fay$$_(p)(x)))(Fay$$_(Fay$$_(Prelude.all)(p))(xs));}throw [\"unhandled case in all\",[$p1,$p2]];});};};Prelude.intersperse = function($p1){return function($p2){return new Fay$$$(function(){if (Fay$$_($p2) === null) {return null;}var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var sep = $p1;return Fay$$_(Fay$$_(Fay$$cons)(x))(Fay$$_(Fay$$_(Prelude.prependToAll)(sep))(xs));}throw [\"unhandled case in intersperse\",[$p1,$p2]];});};};Prelude.prependToAll = function($p1){return function($p2){return new Fay$$$(function(){if (Fay$$_($p2) === null) {return null;}var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var sep = $p1;return Fay$$_(Fay$$_(Fay$$cons)(sep))(Fay$$_(Fay$$_(Fay$$cons)(x))(Fay$$_(Fay$$_(Prelude.prependToAll)(sep))(xs)));}throw [\"unhandled case in prependToAll\",[$p1,$p2]];});};};Prelude.intercalate = function($p1){return function($p2){return new Fay$$$(function(){var xss = $p2;var xs = $p1;return Fay$$_(Prelude.concat)(Fay$$_(Fay$$_(Prelude.intersperse)(xs))(xss));});};};Prelude.maximum = function($p1){return new Fay$$$(function(){if (Fay$$_($p1) === null) {return Fay$$_(Prelude.error)(Fay$$list(\"maximum: empty list\"));}var xs = $p1;return Fay$$_(Fay$$_(Prelude.foldl1)(Prelude.max))(xs);});};Prelude.minimum = function($p1){return new Fay$$$(function(){if (Fay$$_($p1) === null) {return Fay$$_(Prelude.error)(Fay$$list(\"minimum: empty list\"));}var xs = $p1;return Fay$$_(Fay$$_(Prelude.foldl1)(Prelude.min))(xs);});};Prelude.product = function($p1){return new Fay$$$(function(){var xs = $p1;return Fay$$_(Fay$$_(Fay$$_(Prelude.foldl)(Fay$$mult))(1))(xs);});};Prelude.sum = function($p1){return new Fay$$$(function(){var xs = $p1;return Fay$$_(Fay$$_(Fay$$_(Prelude.foldl)(Fay$$add))(0))(xs);});};Prelude.scanl = function($p1){return function($p2){return function($p3){return new Fay$$$(function(){var l = $p3;var z = $p2;var f = $p1;return Fay$$_(Fay$$_(Fay$$cons)(z))((function($tmp1){if (Fay$$_($tmp1) === null) {return null;}var $tmp2 = Fay$$_($tmp1);if ($tmp2 instanceof Fay$$Cons) {var x = $tmp2.car;var xs = $tmp2.cdr;return Fay$$_(Fay$$_(Fay$$_(Prelude.scanl)(f))(Fay$$_(Fay$$_(f)(z))(x)))(xs);}return (function(){ throw ([\"unhandled case\",$tmp1]); })();})(l));});};};};Prelude.scanl1 = function($p1){return function($p2){return new Fay$$$(function(){if (Fay$$_($p2) === null) {return null;}var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var f = $p1;return Fay$$_(Fay$$_(Fay$$_(Prelude.scanl)(f))(x))(xs);}throw [\"unhandled case in scanl1\",[$p1,$p2]];});};};Prelude.scanr = function($p1){return function($p2){return function($p3){return new Fay$$$(function(){if (Fay$$_($p3) === null) {var z = $p2;return Fay$$list([z]);}var $tmp1 = Fay$$_($p3);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var z = $p2;var f = $p1;return (function($tmp1){var $tmp2 = Fay$$_($tmp1);if ($tmp2 instanceof Fay$$Cons) {var h = $tmp2.car;var t = $tmp2.cdr;return Fay$$_(Fay$$_(Fay$$cons)(Fay$$_(Fay$$_(f)(x))(h)))(Fay$$_(Fay$$_(Fay$$cons)(h))(t));}return Prelude.$_undefined;})(Fay$$_(Fay$$_(Fay$$_(Prelude.scanr)(f))(z))(xs));}throw [\"unhandled case in scanr\",[$p1,$p2,$p3]];});};};};Prelude.scanr1 = function($p1){return function($p2){return new Fay$$$(function(){if (Fay$$_($p2) === null) {return null;}if (Fay$$listLen(Fay$$_($p2),1)) {var x = Fay$$index(0,Fay$$_($p2));return Fay$$list([x]);}var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;var f = $p1;return (function($tmp1){var $tmp2 = Fay$$_($tmp1);if ($tmp2 instanceof Fay$$Cons) {var h = $tmp2.car;var t = $tmp2.cdr;return Fay$$_(Fay$$_(Fay$$cons)(Fay$$_(Fay$$_(f)(x))(h)))(Fay$$_(Fay$$_(Fay$$cons)(h))(t));}return Prelude.$_undefined;})(Fay$$_(Fay$$_(Prelude.scanr1)(f))(xs));}throw [\"unhandled case in scanr1\",[$p1,$p2]];});};};Prelude.lookup = function($p1){return function($p2){return new Fay$$$(function(){if (Fay$$_($p2) === null) {var _key = $p1;return Prelude.Nothing;}var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {if (Fay$$listLen(Fay$$_($tmp1.car),2)) {var x = Fay$$index(0,Fay$$_($tmp1.car));var y = Fay$$index(1,Fay$$_($tmp1.car));var xys = $tmp1.cdr;var key = $p1;return Fay$$_(Fay$$_(Fay$$_(Fay$$eq)(key))(x)) ? Fay$$_(Prelude.Just)(y) : Fay$$_(Fay$$_(Prelude.lookup)(key))(xys);}}throw [\"unhandled case in lookup\",[$p1,$p2]];});};};Prelude.length = function($p1){return new Fay$$$(function(){var xs = $p1;return Fay$$_(Fay$$_(Prelude.length$39$)(0))(xs);});};Prelude.length$39$ = function($p1){return function($p2){return new Fay$$$(function(){var $tmp1 = Fay$$_($p2);if ($tmp1 instanceof Fay$$Cons) {var xs = $tmp1.cdr;var acc = $p1;return Fay$$_(Fay$$_(Prelude.length$39$)(Fay$$_(Fay$$_(Fay$$add)(acc))(1)))(xs);}var acc = $p1;return acc;});};};Prelude.reverse = function($p1){return new Fay$$$(function(){var $tmp1 = Fay$$_($p1);if ($tmp1 instanceof Fay$$Cons) {var x = $tmp1.car;var xs = $tmp1.cdr;return Fay$$_(Fay$$_(Prelude.$43$$43$)(Fay$$_(Prelude.reverse)(xs)))(Fay$$list([x]));}if (Fay$$_($p1) === null) {return null;}throw [\"unhandled case in reverse\",[$p1]];});};Prelude.print = function($p1){return new Fay$$$(function(){return new Fay$$Monad(Fay$$jsToFay([\"unknown\"],(function(x) { if (console && console.log) console.log(x) })(Fay$$fayToJs([\"automatic\"],$p1))));});};Prelude.putStrLn = function($p1){return new Fay$$$(function(){return new Fay$$Monad(Fay$$jsToFay([\"unknown\"],(function(x) { if (console && console.log) console.log(x) })(Fay$$fayToJs_string($p1))));});};Prelude.ifThenElse = function($p1){return function($p2){return function($p3){return new Fay$$$(function(){var b = $p3;var a = $p2;var p = $p1;return Fay$$_(p) ? a : b;});};};};Fay$$objConcat(Fay$$fayToJsHash,{\"Just\": function(type,argTypes,_obj){var obj_ = {\"instance\": \"Just\"};var obj_slot1 = Fay$$fayToJs(argTypes && (argTypes)[0] ? (argTypes)[0] : (type)[0] === \"automatic\" ? [\"automatic\"] : [\"unknown\"],_obj.slot1);if (undefined !== obj_slot1) {obj_['slot1'] = obj_slot1;}return obj_;},\"Nothing\": function(type,argTypes,_obj){var obj_ = {\"instance\": \"Nothing\"};return obj_;},\"Left\": function(type,argTypes,_obj){var obj_ = {\"instance\": \"Left\"};var obj_slot1 = Fay$$fayToJs(argTypes && (argTypes)[0] ? (argTypes)[0] : (type)[0] === \"automatic\" ? [\"automatic\"] : [\"unknown\"],_obj.slot1);if (undefined !== obj_slot1) {obj_['slot1'] = obj_slot1;}return obj_;},\"Right\": function(type,argTypes,_obj){var obj_ = {\"instance\": \"Right\"};var obj_slot1 = Fay$$fayToJs(argTypes && (argTypes)[1] ? (argTypes)[1] : (type)[0] === \"automatic\" ? [\"automatic\"] : [\"unknown\"],_obj.slot1);if (undefined !== obj_slot1) {obj_['slot1'] = obj_slot1;}return obj_;},\"GT\": function(type,argTypes,_obj){var obj_ = {\"instance\": \"GT\"};return obj_;},\"LT\": function(type,argTypes,_obj){var obj_ = {\"instance\": \"LT\"};return obj_;},\"EQ\": function(type,argTypes,_obj){var obj_ = {\"instance\": \"EQ\"};return obj_;}});Fay$$objConcat(Fay$$jsToFayHash,{\"Just\": function(type,argTypes,obj){return new Prelude._Just(Fay$$jsToFay(argTypes && (argTypes)[0] ? (argTypes)[0] : (type)[0] === \"automatic\" ? [\"automatic\"] : [\"unknown\"],obj[\"slot1\"]));},\"Nothing\": function(type,argTypes,obj){return new Prelude._Nothing();},\"Left\": function(type,argTypes,obj){return new Prelude._Left(Fay$$jsToFay(argTypes && (argTypes)[0] ? (argTypes)[0] : (type)[0] === \"automatic\" ? [\"automatic\"] : [\"unknown\"],obj[\"slot1\"]));},\"Right\": function(type,argTypes,obj){return new Prelude._Right(Fay$$jsToFay(argTypes && (argTypes)[1] ? (argTypes)[1] : (type)[0] === \"automatic\" ? [\"automatic\"] : [\"unknown\"],obj[\"slot1\"]));},\"GT\": function(type,argTypes,obj){return new Prelude._GT();},\"LT\": function(type,argTypes,obj){return new Prelude._LT();},\"EQ\": function(type,argTypes,obj){return new Prelude._EQ();}});"

foreign import javascript safe
  "document.getElementById($1).onclick = $2;"
  setOnClickAux :: JSString -> Callback (IO ()) -> IO ()
setOnClick i c = do ac <- asyncCallback c
                    setOnClickAux (pack i) ac

foreign import javascript safe
  "document.getElementById($1).disabled = false;"
  enableButtonAux :: JSString -> IO ()
enableButton i = enableButtonAux (pack i)

foreign import javascript safe
  "document.getElementById($1).disabled = true;"
  disableButtonAux :: JSString -> IO ()
disableButton i = disableButtonAux (pack i)

foreign import javascript safe
  "alert($1);"
  alertAux :: JSString -> IO ()
alert s = alertAux (pack s)

foreign import javascript safe
  "myCodeMirror.setValue($1);"
   setCodeMirrorValueAux :: JSString -> IO ()
setCodeMirrorValue v = setCodeMirrorValueAux (pack v)

foreign import javascript safe
  "textarea.setValue($1);"
  setCodeMirrorValueAux2 :: JSString -> IO ()
setCodeMirrorValue2 v = setCodeMirrorValueAux2 (pack v)

foreign import javascript safe
  "textarea.setOption('mode', $1);"
  setCodeMirrorModeAux2 :: JSString -> IO ()
setCodeMirrorMode2 v = setCodeMirrorModeAux2 (pack v)

foreign import javascript safe
  "textarea.setOption('lineWrapping', $1);"
  setCodeMirrorWrappingAux2 :: JSVal -> IO ()
setCodeMirrorWrapping2 v = setCodeMirrorWrappingAux2 (toJSBool v)

setCodeMirror2Highlight = do setCodeMirrorMode2 "text/x-haskell"
                             setCodeMirrorWrapping2 False
setCodeMirror2Plain = do setCodeMirrorMode2 "text/plain"
                         setCodeMirrorWrapping2 True

foreign import javascript safe
  "document.getElementById($1).value = $2;"
   setValueAux :: JSString -> JSString -> IO ()
setValue i v = setValueAux (pack i) (pack v)

foreign import javascript safe
  "parent[$1].setValue($2);"
   setValueParentAux :: JSString -> JSString -> IO ()
setValueParent i v = setValueParentAux (pack i) (pack v)

foreign import javascript safe
  "$r = myCodeMirror.getValue();"
   getCodeMirrorValueAux :: IO JSString
getCodeMirrorValue = do r <- getCodeMirrorValueAux
                        return (unpack r)

foreign import javascript safe
  "$r = textarea.getValue();"
  getCodeMirrorValueAux2 :: IO JSString
getCodeMirrorValue2 = do r <- getCodeMirrorValueAux2
                         return (unpack r)

foreign import javascript safe
  "$r = document.getElementById($1).value;"
   getValueAux :: JSString -> IO JSString
getValue i = do r <- getValueAux (pack i)
                return (unpack r)

foreign import javascript safe
  "$r = parent[$1].getValue();"
   getValueParentAux :: JSString -> IO JSString
getValueParent i = do r <- getValueParentAux (pack i)
                      return (unpack r)

foreign import javascript safe
  "parent.document.getElementById('iframe').remove();"
  destroyIFrame :: IO ()

foreign import javascript safe
  "parent.document.getElementById('clear').click();"
  clearWorkspace :: IO ()

foreign import javascript safe
  "parent.document.getElementById('c2b').click();"
  codeToBlockly :: IO ()

foreign import javascript safe
  "parent.document.getElementById('iframe').style.display = 'none';"
  hideIFrame :: IO ()

foreign import javascript safe
    "var element = document.createElement('a'); \
    \element.setAttribute('href', 'data:text/plain;charset=utf-8,' + encodeURIComponent($1)); \
    \element.setAttribute('download', $2); \
    \element.style.display = 'none'; \
    \document.body.appendChild(element); \
    \element.click(); \
    \document.body.removeChild(element);"
  downloadFileAux :: JSString -> JSString -> IO ()
downloadFile :: String -> String -> IO ()
downloadFile content name = downloadFileAux (pack content) (pack name)

foreign import javascript safe
    "        function handleFileSelect(evt) { \
    \            var files = evt.target.files; \
    \            var reader = new FileReader(); \
    \              reader.onload = (function(theFile) { \
    \                return function(e) { \
    \                  myCodeMirror.setValue(e.target.result); \
    \                }; \
    \              })(files[0]); \
    \              reader.readAsText(files[0]); \
    \        }; \
    \        var input = $(document.createElement(\"input\")); \
    \        input.attr(\"type\", \"file\"); \
    \        input.attr(\"accept\", \".hs\"); \
    \        input.change(handleFileSelect); \
    \        input.trigger(\"click\");"
  uploadFile :: IO ()

foreign import javascript safe
    "if (window.File && window.FileReader && window.FileList && window.Blob) { $r = true; } else { $r = false; };"
  isUploadSupportedAux :: IO JSVal
isUploadSupported :: IO Bool
isUploadSupported = do b <- isUploadSupportedAux
                       return (fromJSBool b)

compile :: IO ()
compile = do setCodeMirrorValue2 "Compiling...\n\nThis could take more than one minute."
             setCodeMirror2Plain
             disableButton "compile"
             disableButton "reset"
             disableButton "submit"
             disableButton "example"
             disableButton "example2"
             disableButton "upload"
             disableButton "cancel"
             y <- getCodeMirrorValue
             x <- doCompile y
             case x of
                Just x -> do { setCodeMirrorValue2 ("Compilation error:\n\n" ++ x);
                               setCodeMirror2Plain }
                Nothing -> do { enableButton "submit" }
             enableButton "compile"
             enableButton "reset"
             enableButton "example"
             enableButton "example2"
             ies <- isUploadSupported
             if (ies) then enableButton "upload" else (return ())
             enableButton "minimise"
             enableButton "cancel"

embedCode :: [String] -> String
embedCode [] = prefix
embedCode (h:t) = (prefix ++ (h ++ "\n")) ++ (unlines (map ((take 11 $ repeat ' ') ++) t))

reset :: IO ()
reset = do x <- getValueParent "codeArea"
           setCodeMirrorValue $ embedCode $ lines x
           setCodeMirrorValue2 explanation
           setCodeMirror2Plain
           disableButton "submit"

submit :: IO ()
submit = do x <- getCodeMirrorValue2
            clearWorkspace
            setValueParent "codeArea" x
            codeToBlockly

download :: IO ()
download = do c <- getCodeMirrorValue
              downloadFile c "Main.hs" 

upload :: IO ()
upload = return ()

minimise :: IO ()
minimise = hideIFrame

cancel :: IO ()
cancel = destroyIFrame 

example :: IO ()
example = setCodeMirrorValue exampleCode

example2 :: IO ()
example2 = setCodeMirrorValue exampleCode2

main :: IO ()
main = do setOnClick "compile" compile 
          setOnClick "reset" reset 
          setOnClick "example" example
          setOnClick "example2" example2
          setOnClick "submit" submit
          setOnClick "download" download
          setOnClick "upload" uploadFile
          setOnClick "minimise" minimise
          setOnClick "cancel" cancel 
          enableButton "compile"
          enableButton "reset"
          enableButton "example"
          enableButton "example2"
          enableButton "download"
          ies <- isUploadSupported
          if (ies) then enableButton "upload" else (return ())
          enableButton "minimise"
          enableButton "cancel"
          reset

prefix = "module Main where\n\nimport Marlowe\nimport Fay.FFI (ffi)\n\nsetCode :: String -> Fay ()\nsetCode = ffi \"textarea.setValue(%1)\"\n\nmain :: Fay ()\nmain = setCode (prettyPrintContract contract)\n\n-------------------------------------\n-- Write your code below this line --\n-------------------------------------\n\n\ncontract :: Contract\ncontract = "

exampleCode = "module Main where\n\nimport Marlowe\nimport Fay.FFI (ffi)\n\nsetCode :: String -> Fay ()\nsetCode = ffi \"textarea.setValue(%1)\"\n\nmain :: Fay ()\nmain = setCode (prettyPrintContract contract)\n\n-------------------------------------\n-- Write your code below this line --\n-------------------------------------\n\n-- Escrow example using embedding\n\ncontract :: Contract\ncontract = CommitCash iCC1 alice\n                      (ConstMoney 450)\n                      10 100\n                      (When (OrObs (majority_chose refund)\n                                   (majority_chose pay))\n                            90\n                            (Choice (majority_chose pay)\n                                    (Pay iP1 alice bob\n                                         (AvailableMoney iCC1)\n                                         100\n                                         redeem_original)\n                                    redeem_original)\n                            redeem_original)\n                      Null\n    where majority_chose = two_chose alice bob carol\n\n-- Participants\n\nalice, bob, carol :: Person\nalice = 1\nbob = 2\ncarol = 3\n\n-- Possible votes \n\nrefund, pay :: ConcreteChoice\nrefund = 0\npay = 1\n\n-- Vote counting\n\nchose :: Integer -> ConcreteChoice -> Observation\nchose per c = PersonChoseThis (IdentChoice per) per c\n\none_chose :: Person -> Person -> ConcreteChoice -> Observation\none_chose per per' val = (OrObs (chose per val) (chose per' val)) \n                                  \ntwo_chose :: Person -> Person -> Person -> ConcreteChoice -> Observation\ntwo_chose p1 p2 p3 c = OrObs (AndObs (chose p1 c) (one_chose p2 p3 c))\n                             (AndObs (chose p2 c) (chose p3 c))\n\n-- Redeem alias\n\nredeem_original :: Contract\nredeem_original = RedeemCC iCC1 Null\n\n-- Commit identifier \n\niCC1 :: IdentCC\niCC1 = IdentCC 1\n\n-- Payment identifier\n\niP1 :: IdentPay\niP1 = IdentPay 1\n\n"

exampleCode2 = "module Main where\n\nimport Marlowe\nimport Fay.FFI (ffi)\n\nsetCode :: String -> Fay ()\nsetCode = ffi \"textarea.setValue(%1)\"\n\nmain :: Fay ()\nmain = setCode (prettyPrintContract contract)\n\n-------------------------------------\n-- Write your code below this line --\n-------------------------------------\n\n-- Zero Coupon Bond example using embedding\n\ncontract :: Contract\ncontract = couponBondGuaranteed 1 2 3 1000 0.08 50 100 450 30240\n\ncouponBondGuaranteed :: Integer -> Integer -> Integer -> Integer -> Double -> Timeout\n                     -> Timeout -> Timeout -> Timeout -> Contract\ncouponBondGuaranteed creatorID counterpartyID guarantor notionalPrincipal nominalInterestRate initialExchangeDate slotCycle maturityDate gracePeriod =\n    -- counterpartyID commits a bond face value before initialExchangeDate\n    CommitCash (IdentCC 0) counterpartyID (ConstMoney notionalPrincipal) initialExchangeDate maturityDate\n        -- guarantor commits a 'guarantee' before initialExchangeDate\n        (CommitCash (IdentCC 1) guarantor (ConstMoney totalPayment) initialExchangeDate (maturityDate + gracePeriod)\n            (Both\n                -- creatorID can receive the payment from counterpartyID\n                (Pay (IdentPay 1) counterpartyID creatorID (AvailableMoney (IdentCC 0)) maturityDate Null)\n                -- schedule payments\n                (Both payments finalPayment)\n            )\n            -- if no guarantee committed we abort contract and allow to redeem the counterpartyID's commit\n            (RedeemCC (IdentCC 0) Null)\n        )\n        Null\n  where\n    cycles = takeWhile (\\i ->\n            let paymentDate = initialExchangeDate + i * slotCycle\n            in paymentDate < maturityDate\n        ) [1..]\n\n    -- calculate payment schedule\n    paymentDates = map (\\i -> initialExchangeDate + i * slotCycle) cycles\n\n    coupon = round $ fromIntegral notionalPrincipal * nominalInterestRate\n\n    -- calculate total amount of payments to be ensured by guarantor\n    totalPayment = notionalPrincipal + coupon * length cycles\n\n    -- generate Commit/Pay for each scheduled payment\n    payment amount (ident, paymentDate) =\n        -- creatorID commits a coupon payment\n        CommitCash (IdentCC ident) creatorID (ConstMoney amount) paymentDate (maturityDate + gracePeriod)\n            (When FalseObs paymentDate Null\n                -- counterpartyID can claim the coupon after payment date\n                (Pay (IdentPay ident) creatorID counterpartyID (AvailableMoney (IdentCC ident)) (maturityDate + gracePeriod) Null))\n            -- in case creatorID did not commit on time the guarantor pays the coupon\n            (Pay (IdentPay (ident + 1)) guarantor counterpartyID (ConstMoney amount) (maturityDate + gracePeriod) Null)\n\n    -- generate coupon payments for given schedule\n    payments = foldr1 Both $ map (payment coupon) idsAndDates\n        -- generate IdentCC/IdentPay identifiers for each payment date\n        where idsAndDates = zip (map (2*) [1..]) paymentDates\n\n    finalPayment = payment notionalPrincipal (2 * (1 + length paymentDates), maturityDate)\n"

explanation = "Embedded Fay code editor\n========================\n\nYou can use this editor to generate Marlowe code (to use with Meadow) by using Marlowe's Fay embedding.\n\nFay is a subset of Haskell (https://github.com/faylang/fay/wiki)\n\nThe editor includes a pruned version of the Fay compiler. You can control the editor and the compiler by using the buttons at the bottom:\n\n* Execute Fay code - compiles and runs the Fay code on the left panel and writes the output to this panel.\n\n* Import Meadow contract to Fay code - creates a template based on the Marlowe contract in Meadow (under the editor) and shows this message. If you have just opened the Fay editor the code in Meadow has already been imported.\n\n* Load escrow example - loads, in the left panel, an example of how the Fay embedding of Marlowe can be used to implement an escrow contract.\n\n* Load coupon bond guaranteed example - loads, in the left panel, an example of how the Fay embedding of Marlowe can be used to implement a safe coupon bond guaranteed contract.\n\n* Export generated contract to Meadow - once you have successfully generated a Marlowe contract from the Fay code by clicking the \"Execute Fay code\" button, this button will allow you to copy the generated contract (which will appear on this panel) back to Marlowe (under this editor).\n\n* Load Fay code from file - allows you to select a \".hs\" file from your computer that will be displayed on the left panel.\n\n* Save Fay code to file - allows you to save the code on the left panel to a \".hs\" file in your computer.\n\n* Minimise Fay editor - will hide the Fay editor so that you can keep using Meadow, but it will not delete its contents. If Fay code is being executed or compiled when you minimise the editor, the process will continue in the background.\n\n* Close Fay editor - it closes the editor. WARNING: if you close the editor or navigate away from this page, the contents of the editor will be lost. Make sure you save them to a file in your computer before that.\n\nPlease note that the compiler included does not do type-checking of the code provided. This is because the Fay compiler relies on GHC for that, and this demo runs in the browser (so it does not have access to GHC). You can use GHC offline in order to type-check your programs, the source for the Marlowe module can be found in the path \"/meadow/editor/fay-code\" of the Github repository.\n\n\n"

